/* DuplicityJob.c generated by valac 0.40.11, the Vala compiler
 * generated from DuplicityJob.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "deja.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>


#define TYPE_DUPLICITY_JOB (duplicity_job_get_type ())
#define DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_JOB, DuplicityJob))
#define DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_JOB, DuplicityJobClass))
#define IS_DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_JOB))
#define IS_DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_JOB))
#define DUPLICITY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_JOB, DuplicityJobClass))

typedef struct _DuplicityJob DuplicityJob;
typedef struct _DuplicityJobClass DuplicityJobClass;
typedef struct _DuplicityJobPrivate DuplicityJobPrivate;

#define DUPLICITY_JOB_TYPE_STATE (duplicity_job_state_get_type ())

#define TYPE_DUPLICITY_INSTANCE (duplicity_instance_get_type ())
#define DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstance))
#define DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))
#define IS_DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_INSTANCE))
#define IS_DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_INSTANCE))
#define DUPLICITY_INSTANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))

typedef struct _DuplicityInstance DuplicityInstance;
typedef struct _DuplicityInstanceClass DuplicityInstanceClass;

#define DUPLICITY_JOB_TYPE_DATE_INFO (duplicity_job_date_info_get_type ())
typedef struct _DuplicityJobDateInfo DuplicityJobDateInfo;
enum  {
	DUPLICITY_JOB_0_PROPERTY,
	DUPLICITY_JOB_STATE_PROPERTY,
	DUPLICITY_JOB_NUM_PROPERTIES
};
static GParamSpec* duplicity_job_properties[DUPLICITY_JOB_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DuplicityJobAsyncSetupData DuplicityJobAsyncSetupData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _DuplicityJobCheckBackupSpaceData DuplicityJobCheckBackupSpaceData;

typedef enum  {
	GPG_ERR_BAD_KEY = 19
} gpg_err_code_t;

struct _DuplicityJob {
	DejaDupToolJob parent_instance;
	DuplicityJobPrivate * priv;
};

struct _DuplicityJobClass {
	DejaDupToolJobClass parent_class;
	void (*process_error) (DuplicityJob* self, gchar** firstline, int firstline_length1, GList* data, const gchar* text_in);
	void (*process_info) (DuplicityJob* self, gchar** firstline, int firstline_length1, GList* data, const gchar* text);
	void (*process_warning) (DuplicityJob* self, gchar** firstline, int firstline_length1, GList* data, const gchar* text);
};

typedef enum  {
	DUPLICITY_JOB_STATE_NOT_STARTED,
	DUPLICITY_JOB_STATE_NORMAL,
	DUPLICITY_JOB_STATE_DRY_RUN,
	DUPLICITY_JOB_STATE_STATUS,
	DUPLICITY_JOB_STATE_CHECK_CONTENTS,
	DUPLICITY_JOB_STATE_CLEANUP,
	DUPLICITY_JOB_STATE_DELETE
} DuplicityJobState;

struct _DuplicityJobDateInfo {
	gboolean full;
	GTimeVal time;
};

struct _DuplicityJobPrivate {
	DejaDupToolJobMode _original_mode;
	gboolean _error_issued;
	gboolean _was_stopped;
	DuplicityJobState _state;
	DuplicityInstance* inst;
	GList* backend_argv;
	GList* saved_argv;
	GList* saved_envp;
	gboolean is_full_backup;
	gboolean cleaned_up_once;
	gboolean needs_root;
	gboolean detected_encryption;
	gboolean existing_encrypted;
	gchar* last_bad_volume;
	guint bad_volume_count;
	gboolean has_progress_total;
	guint64 progress_total;
	guint64 progress_count;
	gboolean has_checked_contents;
	gboolean has_non_home_contents;
	GList* homes;
	GList* local_error_files;
	gboolean checked_collection_info;
	gboolean got_collection_info;
	GList* collection_info;
	gboolean checked_backup_space;
	gboolean deleted_files;
	gint delete_age;
	GFile* last_touched_file;
	gchar* forced_cache_dir;
	gchar* saved_status;
	GFile* saved_status_file;
	gboolean saved_status_file_action;
	gboolean restarted_without_cache;
};

struct _DuplicityJobAsyncSetupData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	DejaDupToolJobFlags _tmp0_;
	DejaDupToolJobFlags _tmp1_;
	gchar* template;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	DejaDupBackend* _tmp9_;
	DejaDupBackend* _tmp10_;
	DejaDupBackend* _tmp11_;
	DejaDupBackend* _tmp12_;
	GError* e;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError * _inner_error_;
};

struct _DuplicityJobCheckBackupSpaceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	gboolean _tmp0_;
	guint64 free;
	DejaDupBackend* _tmp1_;
	DejaDupBackend* _tmp2_;
	guint64 total;
	DejaDupBackend* _tmp3_;
	DejaDupBackend* _tmp4_;
	gboolean _tmp5_;
	guint64 _tmp6_;
	guint64 _tmp7_;
	guint64 _tmp8_;
	guint64 _tmp9_;
	guint64 _tmp10_;
	guint64 _tmp11_;
	guint64 _tmp12_;
	guint64 _tmp13_;
	guint64 _tmp14_;
	gboolean _tmp15_;
	gint full_dates;
	GList* _tmp16_;
	GList* info_collection;
	GList* info_it;
	DuplicityJobDateInfo info;
	DuplicityJobDateInfo _tmp17_;
	gboolean _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
};


static gpointer duplicity_job_parent_class = NULL;
static GFile* duplicity_job_slash;
static GFile* duplicity_job_slash = NULL;
static GFile* duplicity_job_slash_root;
static GFile* duplicity_job_slash_root = NULL;
static GFile* duplicity_job_slash_home;
static GFile* duplicity_job_slash_home = NULL;
static GFile* duplicity_job_slash_home_me;
static GFile* duplicity_job_slash_home_me = NULL;
static GType duplicity_job_type_id = 0;

const gchar* gpg_strerror (gpg_err_code_t code);
GType duplicity_job_register_type (GTypeModule * module);
GType duplicity_job_get_type (void) G_GNUC_CONST;
GType duplicity_job_state_get_type (void) G_GNUC_CONST;
GType duplicity_instance_register_type (GTypeModule * module);
GType duplicity_instance_get_type (void) G_GNUC_CONST;
static GType duplicity_job_date_info_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static DuplicityJobDateInfo* duplicity_job_date_info_dup (const DuplicityJobDateInfo* self);
static void duplicity_job_date_info_free (DuplicityJobDateInfo* self);
#define DUPLICITY_JOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DUPLICITY_JOB, DuplicityJobPrivate))
static void duplicity_job_network_changed (DuplicityJob* self);
static void _duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _duplicity_job_date_info_free0_ (gpointer var);
static inline void _g_list_free__duplicity_job_date_info_free0_ (GList* self);
#define DUPLICITY_JOB_MINIMUM_FULL 2
#define DUPLICITY_JOB_ERROR_GENERIC 1
#define DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED 3
#define DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND 19
#define DUPLICITY_JOB_ERROR_EXCEPTION 30
#define DUPLICITY_JOB_ERROR_GPG 31
#define DUPLICITY_JOB_ERROR_BAD_VOLUME 44
#define DUPLICITY_JOB_ERROR_BACKEND 50
#define DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED 51
#define DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND 52
#define DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE 53
#define DUPLICITY_JOB_INFO_PROGRESS 2
#define DUPLICITY_JOB_INFO_COLLECTION_STATUS 3
#define DUPLICITY_JOB_INFO_DIFF_FILE_NEW 4
#define DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED 5
#define DUPLICITY_JOB_INFO_DIFF_FILE_DELETED 6
#define DUPLICITY_JOB_INFO_PATCH_FILE_WRITING 7
#define DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING 8
#define DUPLICITY_JOB_INFO_FILE_STAT 10
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN 11
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN 12
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_DONE 13
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_DONE 14
#define DUPLICITY_JOB_WARNING_ORPHANED_SIG 2
#define DUPLICITY_JOB_WARNING_UNNECESSARY_SIG 3
#define DUPLICITY_JOB_WARNING_UNMATCHED_SIG 4
#define DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP 5
#define DUPLICITY_JOB_WARNING_ORPHANED_BACKUP 6
#define DUPLICITY_JOB_WARNING_CANNOT_READ 10
#define DUPLICITY_JOB_WARNING_CANNOT_PROCESS 12
#define DUPLICITY_JOB_DEBUG_GENERIC 1
static void duplicity_job_real_start (DejaDupToolJob* base);
static DejaDupToolJobMode duplicity_job_get_original_mode (DuplicityJob* self);
static void duplicity_job_set_original_mode (DuplicityJob* self,
                                      DejaDupToolJobMode value);
static void duplicity_job_process_include_excludes (DuplicityJob* self);
static void duplicity_job_async_setup (DuplicityJob* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
static void duplicity_job_async_setup_finish (DuplicityJob* self,
                                       GAsyncResult* _res_);
static void duplicity_job_async_setup_data_free (gpointer _data);
static gboolean duplicity_job_async_setup_co (DuplicityJobAsyncSetupData* _data_);
static void duplicity_job_async_setup_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void duplicity_job_continue_with_envp (DuplicityJob* self,
                                       DejaDupBackend* b,
                                       gboolean success,
                                       GList* envp,
                                       const gchar* _error_);
static void _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready (DejaDupBackend* _sender,
                                                                    gboolean success,
                                                                    GList* envp,
                                                                    const gchar* _error_,
                                                                    gpointer self);
static gboolean duplicity_job_restart (DuplicityJob* self);
static gint duplicity_job_cmp_prefix (DuplicityJob* self,
                               GFile* a,
                               GFile* b);
static gchar* duplicity_job_get_remote (DuplicityJob* self);
static void duplicity_job_expand_links_in_file (DuplicityJob* self,
                                         GFile* file,
                                         GList* * all,
                                         gboolean include,
                                         GList* seen);
static gint ______lambda6_ (GFile* a,
                     GFile* b);
static gint _______lambda6__gcompare_func (gconstpointer a,
                                    gconstpointer b);
static void duplicity_job_expand_links_in_list (DuplicityJob* self,
                                         GList* * all,
                                         gboolean include);
static gchar* duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                            const gchar* path);
static void duplicity_job_real_cancel (DejaDupToolJob* base);
DuplicityJobState duplicity_job_get_state (DuplicityJob* self);
static gboolean duplicity_job_cleanup (DuplicityJob* self);
static void duplicity_job_cancel_inst (DuplicityJob* self);
static void duplicity_job_real_stop (DejaDupToolJob* base);
static void duplicity_job_set_was_stopped (DuplicityJob* self,
                                    gboolean value);
static void duplicity_job_real_pause (DejaDupToolJob* base,
                               const gchar* reason);
void duplicity_instance_pause (DuplicityInstance* self);
static void duplicity_job_set_status (DuplicityJob* self,
                               const gchar* msg,
                               gboolean save);
static void duplicity_job_real_resume (DejaDupToolJob* base);
void duplicity_instance_resume (DuplicityInstance* self);
static void duplicity_job_set_saved_status (DuplicityJob* self);
static void duplicity_job_disconnect_inst (DuplicityJob* self);
static void duplicity_job_handle_done (DuplicityJob* self,
                                DuplicityInstance* inst,
                                gboolean success,
                                gboolean cancelled);
void duplicity_job_set_state (DuplicityJob* self,
                              DuplicityJobState value);
static void duplicity_job_check_backup_space (DuplicityJob* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                              GAsyncResult* _res_);
static void duplicity_job_delete_cache (DuplicityJob* self);
static GFile* duplicity_job_make_local_rel_path (DuplicityJob* self,
                                          GFile* file);
static void duplicity_job_show_error (DuplicityJob* self,
                               const gchar* errorstr,
                               const gchar* detail);
static void duplicity_job_connect_and_start (DuplicityJob* self,
                                      GList* argv_extra,
                                      GList* envp_extra,
                                      GList* argv_entire,
                                      GFile* custom_local);
static void duplicity_job_check_backup_space_data_free (gpointer _data);
static gboolean duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_);
static void duplicity_job_check_backup_space_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void duplicity_job_delete_excess (DuplicityJob* self,
                                  gint cutoff);
static gboolean duplicity_job_can_ignore_error (DuplicityJob* self);
static gboolean duplicity_job_delete_files_if_needed (DuplicityJob* self);
static gboolean duplicity_job_get_was_stopped (DuplicityJob* self);
static gboolean duplicity_job_get_error_issued (DuplicityJob* self);
static void duplicity_job_set_status_file (DuplicityJob* self,
                                    GFile* file,
                                    gboolean action,
                                    gboolean save);
static gboolean duplicity_job_restart_without_cache (DuplicityJob* self);
static void duplicity_job_handle_exit (DuplicityJob* self,
                                gint code);
static void duplicity_job_handle_message (DuplicityJob* self,
                                   DuplicityInstance* inst,
                                   gchar** control_line,
                                   int control_line_length1,
                                   GList* data_lines,
                                   const gchar* user_text);
void duplicity_job_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  int firstline_length1,
                                  GList* data,
                                  const gchar* text_in);
void duplicity_job_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 int firstline_length1,
                                 GList* data,
                                 const gchar* text);
void duplicity_job_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    int firstline_length1,
                                    GList* data,
                                    const gchar* text);
static gboolean duplicity_job_ask_question (DuplicityJob* self,
                                     const gchar* t,
                                     const gchar* m);
static gchar* duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                           const gchar* file,
                                           gint skip_bits);
static void duplicity_job_real_process_error (DuplicityJob* self,
                                       gchar** firstline,
                                       int firstline_length1,
                                       GList* data,
                                       const gchar* text_in);
static void duplicity_job_process_exception (DuplicityJob* self,
                                      const gchar* exception,
                                      const gchar* text);
static GFile* duplicity_job_make_file_obj (DuplicityJob* self,
                                    const gchar* file);
static void duplicity_job_real_process_info (DuplicityJob* self,
                                      gchar** firstline,
                                      int firstline_length1,
                                      GList* data,
                                      const gchar* text);
static void duplicity_job_process_diff_file (DuplicityJob* self,
                                      const gchar* file);
static void duplicity_job_process_patch_file (DuplicityJob* self,
                                       const gchar* file);
static void duplicity_job_process_progress (DuplicityJob* self,
                                     gchar** firstline,
                                     int firstline_length1);
static void duplicity_job_process_collection_status (DuplicityJob* self,
                                              GList* lines);
static void duplicity_job_process_file_stat (DuplicityJob* self,
                                      const gchar* date,
                                      const gchar* file,
                                      GList* data,
                                      const gchar* text);
static void duplicity_job_real_process_warning (DuplicityJob* self,
                                         gchar** firstline,
                                         int firstline_length1,
                                         GList* data,
                                         const gchar* text);
static void duplicity_job_set_error_issued (DuplicityJob* self,
                                     gboolean value);
static gint duplicity_job_get_volsize (DuplicityJob* self);
static void _duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                         gboolean success,
                                                         gboolean cancelled,
                                                         gpointer self);
static void _duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                               gchar** control_line,
                                                               int control_line_length1,
                                                               GList* data_lines,
                                                               const gchar* user_text,
                                                               gpointer self);
static void _duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                           gint code,
                                                           gpointer self);
void duplicity_instance_cancel (DuplicityInstance* self);
DuplicityInstance* duplicity_instance_new (void);
DuplicityInstance* duplicity_instance_construct (GType object_type);
void duplicity_instance_set_forced_cache_dir (DuplicityInstance* self,
                                              const gchar* value);
void duplicity_instance_start (DuplicityInstance* self,
                               GList* argv_in,
                               GList* envp_in,
                               gboolean as_root,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
void duplicity_instance_start_finish (DuplicityInstance* self,
                                      GAsyncResult* _res_);
DuplicityJob* duplicity_job_new (void);
DuplicityJob* duplicity_job_construct (GType object_type);
static GObject * duplicity_job_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void duplicity_job_finalize (GObject * obj);
static void _vala_duplicity_job_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_duplicity_job_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void
_duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	duplicity_job_network_changed ((DuplicityJob*) self);
}


GType
duplicity_job_state_get_type (void)
{
	static volatile gsize duplicity_job_state_type_id__volatile = 0;
	if (g_once_init_enter (&duplicity_job_state_type_id__volatile)) {
		static const GEnumValue values[] = {{DUPLICITY_JOB_STATE_NOT_STARTED, "DUPLICITY_JOB_STATE_NOT_STARTED", "not-started"}, {DUPLICITY_JOB_STATE_NORMAL, "DUPLICITY_JOB_STATE_NORMAL", "normal"}, {DUPLICITY_JOB_STATE_DRY_RUN, "DUPLICITY_JOB_STATE_DRY_RUN", "dry-run"}, {DUPLICITY_JOB_STATE_STATUS, "DUPLICITY_JOB_STATE_STATUS", "status"}, {DUPLICITY_JOB_STATE_CHECK_CONTENTS, "DUPLICITY_JOB_STATE_CHECK_CONTENTS", "check-contents"}, {DUPLICITY_JOB_STATE_CLEANUP, "DUPLICITY_JOB_STATE_CLEANUP", "cleanup"}, {DUPLICITY_JOB_STATE_DELETE, "DUPLICITY_JOB_STATE_DELETE", "delete"}, {0, NULL, NULL}};
		GType duplicity_job_state_type_id;
		duplicity_job_state_type_id = g_enum_register_static ("DuplicityJobState", values);
		g_once_init_leave (&duplicity_job_state_type_id__volatile, duplicity_job_state_type_id);
	}
	return duplicity_job_state_type_id__volatile;
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


static void
_duplicity_job_date_info_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (duplicity_job_date_info_free (var), NULL));
}


static inline void
_g_list_free__duplicity_job_date_info_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _duplicity_job_date_info_free0_);
}


static void
duplicity_job_network_changed (DuplicityJob* self)
{
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = deja_dup_network_get ();
	_tmp1_ = _tmp0_;
	_tmp2_ = deja_dup_network_get_connected (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		deja_dup_tool_job_resume ((DejaDupToolJob*) self);
	} else {
		deja_dup_tool_job_pause ((DejaDupToolJob*) self, _ ("Paused (no network)"));
	}
}


static void
duplicity_job_real_start (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp3_;
	DejaDupBackend* _tmp4_;
	DejaDupBackend* _tmp5_;
	DejaDupBackend* _tmp6_;
	DejaDupBackend* _tmp7_;
	DejaDupToolJobMode _tmp8_;
	DejaDupToolJobMode _tmp9_;
	DejaDupToolJobMode _tmp10_;
	DejaDupToolJobMode _tmp11_;
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp12_;
	self = (DuplicityJob*) base;
	_tmp0_ = self->priv->_original_mode;
	if (_tmp0_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
		DejaDupToolJobMode _tmp1_;
		DejaDupToolJobMode _tmp2_;
		_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
		_tmp2_ = _tmp1_;
		duplicity_job_set_original_mode (self, _tmp2_);
	}
	_tmp3_ = self->priv->_original_mode;
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp3_);
	(self->priv->saved_argv == NULL) ? NULL : (self->priv->saved_argv = (_g_list_free__g_free0_ (self->priv->saved_argv), NULL));
	self->priv->saved_argv = NULL;
	(self->priv->saved_envp == NULL) ? NULL : (self->priv->saved_envp = (_g_list_free__g_free0_ (self->priv->saved_envp), NULL));
	self->priv->saved_envp = NULL;
	(self->priv->backend_argv == NULL) ? NULL : (self->priv->backend_argv = (_g_list_free__g_free0_ (self->priv->backend_argv), NULL));
	self->priv->backend_argv = NULL;
	_tmp4_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
	_tmp5_ = _tmp4_;
	deja_dup_backend_add_argv (_tmp5_, DEJA_DUP_TOOL_JOB_MODE_INVALID, &self->priv->backend_argv);
	_tmp6_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
	_tmp7_ = _tmp6_;
	_tmp8_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp9_ = _tmp8_;
	deja_dup_backend_add_argv (_tmp7_, _tmp9_, &self->priv->saved_argv);
	_tmp10_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp11_ = _tmp10_;
	if (_tmp11_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
		duplicity_job_process_include_excludes (self);
	}
	_tmp12_ = deja_dup_get_settings (NULL);
	settings = _tmp12_;
	self->priv->delete_age = g_settings_get_int ((GSettings*) settings, DEJA_DUP_DELETE_AFTER_KEY);
	duplicity_job_async_setup (self, NULL, NULL);
	_g_object_unref0 (settings);
}


static void
duplicity_job_async_setup_data_free (gpointer _data)
{
	DuplicityJobAsyncSetupData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DuplicityJobAsyncSetupData, _data_);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
duplicity_job_async_setup (DuplicityJob* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	DuplicityJobAsyncSetupData* _data_;
	DuplicityJob* _tmp0_;
	_data_ = g_slice_new0 (DuplicityJobAsyncSetupData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_async_setup_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	duplicity_job_async_setup_co (_data_);
}


static void
duplicity_job_async_setup_finish (DuplicityJob* self,
                                  GAsyncResult* _res_)
{
	DuplicityJobAsyncSetupData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void
duplicity_job_async_setup_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	DuplicityJobAsyncSetupData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	duplicity_job_async_setup_co (_data_);
}


static void
_duplicity_job_continue_with_envp_deja_dup_backend_envp_ready (DejaDupBackend* _sender,
                                                               gboolean success,
                                                               GList* envp,
                                                               const gchar* _error_,
                                                               gpointer self)
{
	duplicity_job_continue_with_envp ((DuplicityJob*) self, _sender, success, envp, _error_);
}


static gboolean
duplicity_job_async_setup_co (DuplicityJobAsyncSetupData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) _data_->self);
	_data_->_tmp1_ = _data_->_tmp0_;
	if ((_data_->_tmp1_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_CACHE) != 0) {
		_data_->_state_ = 1;
		deja_dup_get_tempdir (duplicity_job_async_setup_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp2_ = deja_dup_get_tempdir_finish (_data_->_res_);
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp4_ = g_build_filename (_data_->_tmp3_, "duplicity-XXXXXX", NULL);
		_data_->_tmp5_ = _data_->_tmp4_;
		_g_free0 (_data_->_tmp3_);
		_data_->template = _data_->_tmp5_;
		_data_->_tmp6_ = _data_->template;
		_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
		_data_->_tmp8_ = mkdtemp (_data_->_tmp7_);
		_g_free0 (_data_->self->priv->forced_cache_dir);
		_data_->self->priv->forced_cache_dir = _data_->_tmp8_;
		_g_free0 (_data_->template);
	}
	{
		_data_->_tmp9_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
		_data_->_tmp10_ = _data_->_tmp9_;
		g_signal_connect_object (_data_->_tmp10_, "envp-ready", (GCallback) _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready, _data_->self, 0);
		_data_->_tmp11_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
		_data_->_tmp12_ = _data_->_tmp11_;
		_data_->_state_ = 2;
		deja_dup_backend_get_envp (_data_->_tmp12_, duplicity_job_async_setup_ready, _data_);
		return FALSE;
		_state_2:
		deja_dup_backend_get_envp_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error_);
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		_data_->e = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_data_->_tmp13_ = _data_->e;
		_data_->_tmp14_ = _data_->_tmp13_->message;
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "raise-error", _data_->_tmp14_, NULL);
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
		_g_error_free0 (_data_->e);
	}
	__finally4:
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
duplicity_job_continue_with_envp (DuplicityJob* self,
                                  DejaDupBackend* b,
                                  gboolean success,
                                  GList* envp,
                                  const gchar* _error_)
{
	DejaDupBackend* _tmp0_;
	DejaDupBackend* _tmp1_;
	guint _tmp2_;
	DejaDupBackend* _tmp6_;
	DejaDupBackend* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (b != NULL);
	_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	g_signal_parse_name ("envp-ready", DEJA_DUP_TYPE_BACKEND, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _duplicity_job_continue_with_envp_deja_dup_backend_envp_ready, self);
	if (!success) {
		if (_error_ != NULL) {
			g_signal_emit_by_name ((DejaDupToolJob*) self, "raise-error", _error_, NULL);
		}
		g_signal_emit_by_name ((DejaDupToolJob*) self, "done", FALSE, FALSE, NULL);
		return;
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = envp;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp3_;
			gchar* s = NULL;
			_tmp3_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp3_;
			{
				const gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp4_ = s;
				_tmp5_ = g_strdup (_tmp4_);
				self->priv->saved_envp = g_list_append (self->priv->saved_envp, _tmp5_);
				_g_free0 (s);
			}
		}
	}
	if (!duplicity_job_restart (self)) {
		g_signal_emit_by_name ((DejaDupToolJob*) self, "done", FALSE, FALSE, NULL);
	}
	_tmp6_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
	_tmp7_ = _tmp6_;
	if (!deja_dup_backend_is_native (_tmp7_)) {
		DejaDupNetwork* _tmp8_;
		DejaDupNetwork* _tmp9_;
		DejaDupNetwork* _tmp10_;
		DejaDupNetwork* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp8_ = deja_dup_network_get ();
		_tmp9_ = _tmp8_;
		g_signal_connect_object ((GObject*) _tmp9_, "notify::connected", (GCallback) _duplicity_job_network_changed_g_object_notify, self, 0);
		_g_object_unref0 (_tmp9_);
		_tmp10_ = deja_dup_network_get ();
		_tmp11_ = _tmp10_;
		_tmp12_ = deja_dup_network_get_connected (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = !_tmp13_;
		_g_object_unref0 (_tmp11_);
		if (_tmp14_) {
			g_debug ("DuplicityJob.vala:180: No connection found. Postponing the backup.");
			deja_dup_tool_job_pause ((DejaDupToolJob*) self, _ ("Paused (no network)"));
		}
	}
}


static gint
duplicity_job_cmp_prefix (DuplicityJob* self,
                          GFile* a,
                          GFile* b)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, 0);
	if (a == NULL) {
		_tmp0_ = b == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	} else {
		gboolean _tmp1_ = FALSE;
		if (b == NULL) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = g_file_has_prefix (a, b);
		}
		if (_tmp1_) {
			result = -1;
			return result;
		} else {
			gboolean _tmp2_ = FALSE;
			if (a == NULL) {
				_tmp2_ = TRUE;
			} else {
				_tmp2_ = g_file_has_prefix (b, a);
			}
			if (_tmp2_) {
				result = 1;
				return result;
			} else {
				result = 0;
				return result;
			}
		}
	}
}


static gchar*
duplicity_job_get_remote (DuplicityJob* self)
{
	gchar* result = NULL;
	DejaDupBackend* _tmp0_;
	DejaDupBackend* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = deja_dup_backend_get_location (_tmp1_, &self->priv->needs_root);
	result = _tmp2_;
	return result;
}


static gint
______lambda6_ (GFile* a,
                GFile* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	if (a != NULL) {
		_tmp2_ = b != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = g_file_equal (a, b);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = 0;
	} else {
		_tmp0_ = 1;
	}
	result = _tmp0_;
	return result;
}


static gint
_______lambda6__gcompare_func (gconstpointer a,
                               gconstpointer b)
{
	gint result;
	result = ______lambda6_ ((GFile*) a, (GFile*) b);
	return result;
}


static void
duplicity_job_expand_links_in_file (DuplicityJob* self,
                                    GFile* file,
                                    GList* * all,
                                    gboolean include,
                                    GList* seen)
{
	GList* pieces = NULL;
	GFile* iter = NULL;
	GFile* _tmp0_;
	GFile* parent = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	pieces = NULL;
	_tmp0_ = _g_object_ref0 (file);
	iter = _tmp0_;
	while (TRUE) {
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		_tmp1_ = iter;
		_tmp2_ = g_file_get_parent (_tmp1_);
		_g_object_unref0 (parent);
		parent = _tmp2_;
		_tmp3_ = parent;
		if (!(_tmp3_ != NULL)) {
			break;
		}
		_tmp4_ = parent;
		_tmp5_ = iter;
		_tmp6_ = g_file_get_relative_path (_tmp4_, _tmp5_);
		pieces = g_list_prepend (pieces, _tmp6_);
		_tmp7_ = parent;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_g_object_unref0 (iter);
		iter = _tmp8_;
	}
	{
		GFile* so_far = NULL;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GList* _tmp11_;
		_tmp9_ = duplicity_job_slash;
		_tmp10_ = _g_object_ref0 (_tmp9_);
		so_far = _tmp10_;
		_tmp11_ = pieces;
		{
			GList* piece_collection = NULL;
			GList* piece_it = NULL;
			piece_collection = _tmp11_;
			for (piece_it = piece_collection; piece_it != NULL; piece_it = piece_it->next) {
				const gchar* piece = NULL;
				piece = (const gchar*) piece_it->data;
				{
					GFile* _tmp12_;
					GFile* _tmp13_;
					GFile* _tmp14_;
					const gchar* _tmp15_;
					GFile* _tmp16_;
					GFileInfo* info = NULL;
					GFile* _tmp17_;
					GFileInfo* _tmp18_;
					GFileInfo* _tmp19_;
					_tmp12_ = so_far;
					_tmp13_ = _g_object_ref0 (_tmp12_);
					_g_object_unref0 (parent);
					parent = _tmp13_;
					_tmp14_ = parent;
					_tmp15_ = piece;
					_tmp16_ = g_file_resolve_relative_path (_tmp14_, _tmp15_);
					_g_object_unref0 (so_far);
					so_far = _tmp16_;
					_tmp17_ = so_far;
					_tmp18_ = g_file_query_info (_tmp17_, G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK "," G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
					info = _tmp18_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						_g_object_unref0 (so_far);
						if (g_error_matches (_inner_error_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
							goto __catch5_g_io_error_not_found;
						}
						goto __catch5_g_error;
					}
					_tmp19_ = info;
					if (g_file_info_get_is_symlink (_tmp19_)) {
						GFile* _tmp20_;
						GList* _tmp21_;
						gchar* symlink_target = NULL;
						GFileInfo* _tmp24_;
						const gchar* _tmp25_;
						gchar* _tmp26_;
						GFile* full_target = NULL;
						const gchar* _tmp27_;
						gchar* remaining = NULL;
						GFile* _tmp33_;
						gchar* _tmp34_;
						const gchar* _tmp35_;
						GFile* _tmp39_;
						GFile* _tmp40_;
						GFile* _tmp41_;
						_tmp20_ = so_far;
						_tmp21_ = g_list_find_custom (seen, _tmp20_, _______lambda6__gcompare_func);
						if (_tmp21_ != NULL) {
							_g_object_unref0 (info);
							_g_object_unref0 (so_far);
							_g_object_unref0 (parent);
							_g_object_unref0 (iter);
							(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
							return;
						}
						if (include) {
							GFile* _tmp22_;
							GFile* _tmp23_;
							_tmp22_ = so_far;
							_tmp23_ = _g_object_ref0 (_tmp22_);
							*all = g_list_append (*all, _tmp23_);
						}
						_tmp24_ = info;
						_tmp25_ = g_file_info_get_symlink_target (_tmp24_);
						_tmp26_ = g_strdup (_tmp25_);
						symlink_target = _tmp26_;
						_tmp27_ = symlink_target;
						if (g_path_is_absolute (_tmp27_)) {
							const gchar* _tmp28_;
							GFile* _tmp29_;
							_tmp28_ = symlink_target;
							_tmp29_ = g_file_new_for_path (_tmp28_);
							_g_object_unref0 (full_target);
							full_target = _tmp29_;
						} else {
							GFile* _tmp30_;
							const gchar* _tmp31_;
							GFile* _tmp32_;
							_tmp30_ = parent;
							_tmp31_ = symlink_target;
							_tmp32_ = g_file_resolve_relative_path (_tmp30_, _tmp31_);
							_g_object_unref0 (full_target);
							full_target = _tmp32_;
						}
						_tmp33_ = so_far;
						_tmp34_ = g_file_get_relative_path (_tmp33_, file);
						remaining = _tmp34_;
						_tmp35_ = remaining;
						if (_tmp35_ != NULL) {
							GFile* _tmp36_;
							const gchar* _tmp37_;
							GFile* _tmp38_;
							_tmp36_ = full_target;
							_tmp37_ = remaining;
							_tmp38_ = g_file_resolve_relative_path (_tmp36_, _tmp37_);
							_g_object_unref0 (full_target);
							full_target = _tmp38_;
						}
						if (include) {
							*all = g_list_remove (*all, file);
						}
						_tmp39_ = so_far;
						_tmp40_ = _g_object_ref0 (_tmp39_);
						seen = g_list_prepend (seen, _tmp40_);
						_tmp41_ = full_target;
						duplicity_job_expand_links_in_file (self, _tmp41_, all, include, seen);
						_g_free0 (remaining);
						_g_object_unref0 (full_target);
						_g_free0 (symlink_target);
						_g_object_unref0 (info);
						_g_object_unref0 (so_far);
						_g_object_unref0 (parent);
						_g_object_unref0 (iter);
						(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
						return;
					}
					_g_object_unref0 (info);
				}
			}
		}
		if (seen != NULL) {
			GFile* _tmp42_;
			_tmp42_ = _g_object_ref0 (file);
			*all = g_list_append (*all, _tmp42_);
		}
		_g_object_unref0 (so_far);
	}
	goto __finally5;
	__catch5_g_io_error_not_found:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		*all = g_list_remove (*all, file);
		_g_error_free0 (e);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp43_ = e;
		_tmp44_ = _tmp43_->message;
		g_warning ("DuplicityJob.vala:278: %s\n", _tmp44_);
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (parent);
		_g_object_unref0 (iter);
		(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (parent);
	_g_object_unref0 (iter);
	(pieces == NULL) ? NULL : (pieces = (_g_list_free__g_free0_ (pieces), NULL));
}


static void
duplicity_job_expand_links_in_list (DuplicityJob* self,
                                    GList* * all,
                                    gboolean include)
{
	GList* all2 = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_list_copy (*all);
	all2 = _tmp0_;
	_tmp1_ = all2;
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
		file_collection = _tmp1_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			GFile* _tmp2_;
			GFile* file = NULL;
			_tmp2_ = _g_object_ref0 ((GFile*) file_it->data);
			file = _tmp2_;
			{
				GFile* _tmp3_;
				_tmp3_ = file;
				duplicity_job_expand_links_in_file (self, _tmp3_, all, include, NULL);
				_g_object_unref0 (file);
			}
		}
	}
	(all2 == NULL) ? NULL : (all2 = (g_list_free (all2), NULL));
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch6_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gchar*
duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                     const gchar* path)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = string_replace (path, "[", "[[]");
	_g_free0 (rv);
	rv = _tmp0_;
	_tmp1_ = rv;
	_tmp2_ = string_replace (_tmp1_, "?", "[?]");
	_g_free0 (rv);
	rv = _tmp2_;
	_tmp3_ = rv;
	_tmp4_ = string_replace (_tmp3_, "*", "[*]");
	_g_free0 (rv);
	rv = _tmp4_;
	result = rv;
	return result;
}


static void
duplicity_job_process_include_excludes (DuplicityJob* self)
{
	GList* _tmp0_;
	GList* _tmp4_;
	GList* _tmp25_;
	gchar* _tmp33_;
	g_return_if_fail (self != NULL);
	duplicity_job_expand_links_in_list (self, &((DejaDupToolJob*) self)->includes, TRUE);
	duplicity_job_expand_links_in_list (self, &((DejaDupToolJob*) self)->excludes, FALSE);
	((DejaDupToolJob*) self)->includes = g_list_sort (((DejaDupToolJob*) self)->includes, (GCompareFunc) duplicity_job_cmp_prefix);
	((DejaDupToolJob*) self)->excludes = g_list_sort (((DejaDupToolJob*) self)->excludes, (GCompareFunc) duplicity_job_cmp_prefix);
	_tmp0_ = ((DejaDupToolJob*) self)->exclude_regexps;
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
		r_collection = _tmp0_;
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
			gchar* _tmp1_;
			gchar* r = NULL;
			_tmp1_ = g_strdup ((const gchar*) r_it->data);
			r = _tmp1_;
			{
				const gchar* _tmp2_;
				gchar* _tmp3_;
				_tmp2_ = r;
				_tmp3_ = g_strconcat ("--exclude=", _tmp2_, NULL);
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp3_);
				_g_free0 (r);
			}
		}
	}
	_tmp4_ = ((DejaDupToolJob*) self)->includes;
	{
		GList* i_collection = NULL;
		GList* i_it = NULL;
		i_collection = _tmp4_;
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
			GFile* _tmp5_;
			GFile* i = NULL;
			_tmp5_ = _g_object_ref0 ((GFile*) i_it->data);
			i = _tmp5_;
			{
				GList* excludes2 = NULL;
				GList* _tmp6_;
				GList* _tmp7_;
				GList* _tmp8_;
				GFile* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				_tmp6_ = ((DejaDupToolJob*) self)->excludes;
				_tmp7_ = g_list_copy (_tmp6_);
				excludes2 = _tmp7_;
				_tmp8_ = excludes2;
				{
					GList* e_collection = NULL;
					GList* e_it = NULL;
					e_collection = _tmp8_;
					for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
						GFile* _tmp9_;
						GFile* e = NULL;
						_tmp9_ = _g_object_ref0 ((GFile*) e_it->data);
						e = _tmp9_;
						{
							GFile* _tmp10_;
							GFile* _tmp11_;
							_tmp10_ = e;
							_tmp11_ = i;
							if (g_file_has_prefix (_tmp10_, _tmp11_)) {
								GFile* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
								gchar* _tmp15_;
								gchar* _tmp16_;
								gchar* _tmp17_;
								GFile* _tmp18_;
								_tmp12_ = e;
								_tmp13_ = g_file_get_path (_tmp12_);
								_tmp14_ = _tmp13_;
								_tmp15_ = duplicity_job_escape_duplicity_path (self, _tmp14_);
								_tmp16_ = _tmp15_;
								_tmp17_ = g_strconcat ("--exclude=", _tmp16_, NULL);
								self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp17_);
								_g_free0 (_tmp16_);
								_g_free0 (_tmp14_);
								_tmp18_ = e;
								((DejaDupToolJob*) self)->excludes = g_list_remove (((DejaDupToolJob*) self)->excludes, _tmp18_);
							}
							_g_object_unref0 (e);
						}
					}
				}
				_tmp19_ = i;
				_tmp20_ = g_file_get_path (_tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = duplicity_job_escape_duplicity_path (self, _tmp21_);
				_tmp23_ = _tmp22_;
				_tmp24_ = g_strconcat ("--include=", _tmp23_, NULL);
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp24_);
				_g_free0 (_tmp23_);
				_g_free0 (_tmp21_);
				(excludes2 == NULL) ? NULL : (excludes2 = (g_list_free (excludes2), NULL));
				_g_object_unref0 (i);
			}
		}
	}
	_tmp25_ = ((DejaDupToolJob*) self)->excludes;
	{
		GList* e_collection = NULL;
		GList* e_it = NULL;
		e_collection = _tmp25_;
		for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
			GFile* _tmp26_;
			GFile* e = NULL;
			_tmp26_ = _g_object_ref0 ((GFile*) e_it->data);
			e = _tmp26_;
			{
				GFile* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				_tmp27_ = e;
				_tmp28_ = g_file_get_path (_tmp27_);
				_tmp29_ = _tmp28_;
				_tmp30_ = duplicity_job_escape_duplicity_path (self, _tmp29_);
				_tmp31_ = _tmp30_;
				_tmp32_ = g_strconcat ("--exclude=", _tmp31_, NULL);
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp32_);
				_g_free0 (_tmp31_);
				_g_free0 (_tmp29_);
				_g_object_unref0 (e);
			}
		}
	}
	_tmp33_ = g_strdup ("--exclude=**");
	self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp33_);
}


static void
duplicity_job_real_cancel (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DejaDupToolJobMode prev_mode = 0;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	gboolean _tmp2_ = FALSE;
	DejaDupToolJobMode _tmp3_;
	self = (DuplicityJob*) base;
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	prev_mode = _tmp1_;
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
	_tmp3_ = prev_mode;
	if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
		DuplicityJobState _tmp4_;
		_tmp4_ = self->priv->_state;
		_tmp2_ = _tmp4_ == DUPLICITY_JOB_STATE_NORMAL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		if (duplicity_job_cleanup (self)) {
			return;
		}
	}
	duplicity_job_cancel_inst (self);
}


static void
duplicity_job_real_stop (DejaDupToolJob* base)
{
	DuplicityJob * self;
	self = (DuplicityJob*) base;
	duplicity_job_set_was_stopped (self, TRUE);
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
	duplicity_job_cancel_inst (self);
}


static void
duplicity_job_real_pause (DejaDupToolJob* base,
                          const gchar* reason)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
	self = (DuplicityJob*) base;
	_tmp0_ = self->priv->inst;
	if (_tmp0_ != NULL) {
		DuplicityInstance* _tmp1_;
		_tmp1_ = self->priv->inst;
		duplicity_instance_pause (_tmp1_);
		if (reason != NULL) {
			duplicity_job_set_status (self, reason, FALSE);
		}
	}
}


static void
duplicity_job_real_resume (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
	self = (DuplicityJob*) base;
	_tmp0_ = self->priv->inst;
	if (_tmp0_ != NULL) {
		DuplicityInstance* _tmp1_;
		_tmp1_ = self->priv->inst;
		duplicity_instance_resume (_tmp1_);
		duplicity_job_set_saved_status (self);
	}
}


static void
duplicity_job_cancel_inst (DuplicityJob* self)
{
	g_return_if_fail (self != NULL);
	duplicity_job_disconnect_inst (self);
	duplicity_job_handle_done (self, NULL, FALSE, TRUE);
}


static gboolean
duplicity_job_restart (DuplicityJob* self)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	GList* _tmp1_;
	DejaDupToolJobMode _tmp2_;
	DejaDupToolJobMode _tmp3_;
	GList* extra_argv = NULL;
	gchar* action_desc = NULL;
	GFile* custom_local = NULL;
	DejaDupToolJobMode _tmp4_;
	const gchar* _tmp77_;
	const gchar* _tmp81_;
	GList* _tmp82_;
	GFile* _tmp83_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_NORMAL);
	_tmp0_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		(self->priv->local_error_files == NULL) ? NULL : (self->priv->local_error_files = (_g_list_free__g_object_unref0_ (self->priv->local_error_files), NULL));
		self->priv->local_error_files = NULL;
	}
	_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
		result = FALSE;
		return result;
	}
	extra_argv = NULL;
	action_desc = NULL;
	custom_local = NULL;
	_tmp4_ = self->priv->_original_mode;
	switch (_tmp4_) {
		case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
		{
			gboolean _tmp5_;
			_tmp5_ = self->priv->checked_collection_info;
			if (!_tmp5_) {
				gchar* _tmp6_;
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
				_tmp6_ = g_strdup (_ ("Preparing…"));
				_g_free0 (action_desc);
				action_desc = _tmp6_;
			} else {
				gboolean _tmp7_ = FALSE;
				DejaDupToolJobFlags _tmp8_;
				DejaDupToolJobFlags _tmp9_;
				_tmp8_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) self);
				_tmp9_ = _tmp8_;
				if ((_tmp9_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_PROGRESS) == 0) {
					gboolean _tmp10_;
					_tmp10_ = self->priv->has_progress_total;
					_tmp7_ = !_tmp10_;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					gchar* _tmp11_;
					gchar* _tmp12_;
					duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DRY_RUN);
					_tmp11_ = g_strdup (_ ("Preparing…"));
					_g_free0 (action_desc);
					action_desc = _tmp11_;
					_tmp12_ = g_strdup ("--dry-run");
					extra_argv = g_list_append (extra_argv, _tmp12_);
				} else {
					gboolean _tmp13_;
					_tmp13_ = self->priv->checked_backup_space;
					if (!_tmp13_) {
						duplicity_job_check_backup_space (self, NULL, NULL);
						result = TRUE;
						_g_object_unref0 (custom_local);
						_g_free0 (action_desc);
						(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
						return result;
					} else {
						gboolean _tmp14_;
						gboolean _tmp15_;
						_tmp14_ = self->priv->has_progress_total;
						if (_tmp14_) {
							g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
						}
						_tmp15_ = self->priv->is_full_backup;
						if (_tmp15_) {
							duplicity_job_delete_cache (self);
						}
					}
				}
			}
			break;
		}
		case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
		{
			gboolean _tmp16_;
			_tmp16_ = self->priv->checked_collection_info;
			if (!_tmp16_) {
				gchar* _tmp17_;
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
				_tmp17_ = g_strdup (_ ("Preparing…"));
				_g_free0 (action_desc);
				action_desc = _tmp17_;
			} else {
				gboolean _tmp18_;
				_tmp18_ = self->priv->has_checked_contents;
				if (!_tmp18_) {
					gchar* _tmp19_;
					deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_LIST);
					duplicity_job_set_state (self, DUPLICITY_JOB_STATE_CHECK_CONTENTS);
					_tmp19_ = g_strdup (_ ("Preparing…"));
					_g_free0 (action_desc);
					action_desc = _tmp19_;
				} else {
					GList* _tmp20_;
					GList* _tmp36_;
					GList* _tmp37_;
					_tmp20_ = self->priv->homes;
					if (g_list_length (_tmp20_) > ((guint) 1)) {
						self->priv->has_non_home_contents = TRUE;
					} else {
						GList* _tmp21_;
						_tmp21_ = self->priv->homes;
						if (g_list_length (_tmp21_) == ((guint) 1)) {
							GFile* old_home = NULL;
							GList* _tmp22_;
							gconstpointer _tmp23_;
							GFile* _tmp24_;
							GFile* new_home = NULL;
							GFile* _tmp25_;
							GFile* _tmp26_;
							GFile* _tmp27_;
							GFile* _tmp28_;
							_tmp22_ = self->priv->homes;
							_tmp23_ = _tmp22_->data;
							_tmp24_ = _g_object_ref0 ((GFile*) _tmp23_);
							old_home = _tmp24_;
							_tmp25_ = duplicity_job_slash_home_me;
							_tmp26_ = _g_object_ref0 (_tmp25_);
							new_home = _tmp26_;
							_tmp27_ = old_home;
							_tmp28_ = new_home;
							if (!g_file_equal (_tmp27_, _tmp28_)) {
								gchar* _tmp29_;
								GFile* _tmp30_;
								GFile* _tmp31_;
								gchar* _tmp32_;
								GFile* _tmp33_;
								GFile* _tmp34_;
								gchar* _tmp35_;
								_tmp29_ = g_strdup ("--rename");
								extra_argv = g_list_append (extra_argv, _tmp29_);
								_tmp30_ = duplicity_job_slash;
								_tmp31_ = old_home;
								_tmp32_ = g_file_get_relative_path (_tmp30_, _tmp31_);
								extra_argv = g_list_append (extra_argv, _tmp32_);
								_tmp33_ = duplicity_job_slash;
								_tmp34_ = new_home;
								_tmp35_ = g_file_get_relative_path (_tmp33_, _tmp34_);
								extra_argv = g_list_append (extra_argv, _tmp35_);
							}
							_g_object_unref0 (new_home);
							_g_object_unref0 (old_home);
						}
					}
					_tmp36_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
					_tmp37_ = _tmp36_;
					if (_tmp37_ != NULL) {
						GFile* local_file = NULL;
						GList* _tmp38_;
						GList* _tmp39_;
						gconstpointer _tmp40_;
						GFile* _tmp41_;
						GFile* _tmp42_;
						gboolean _tmp51_ = FALSE;
						GFile* _tmp52_;
						GFile* _tmp53_;
						GFile* _tmp63_;
						GFile* _tmp64_;
						gchar* rel_file_path = NULL;
						GFile* _tmp65_;
						GList* _tmp66_;
						GList* _tmp67_;
						gconstpointer _tmp68_;
						gchar* _tmp69_;
						const gchar* _tmp70_;
						gchar* _tmp71_;
						_tmp38_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
						_tmp39_ = _tmp38_;
						_tmp40_ = _tmp39_->data;
						_tmp41_ = duplicity_job_make_local_rel_path (self, (GFile*) _tmp40_);
						local_file = _tmp41_;
						_tmp42_ = local_file;
						if (_tmp42_ == NULL) {
							GList* _tmp43_;
							GList* _tmp44_;
							gconstpointer _tmp45_;
							GFile* _tmp46_;
							gchar* _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
							gchar* _tmp50_;
							_tmp43_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
							_tmp44_ = _tmp43_;
							_tmp45_ = _tmp44_->data;
							_tmp46_ = (GFile*) _tmp45_;
							_tmp47_ = g_file_get_parse_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, g_file_get_type ()) ? ((GFile*) _tmp46_) : NULL);
							_tmp48_ = _tmp47_;
							_tmp49_ = g_strdup_printf (_ ("Could not restore ‘%s’: Not a valid file location"), _tmp48_);
							_tmp50_ = _tmp49_;
							duplicity_job_show_error (self, _tmp50_, NULL);
							_g_free0 (_tmp50_);
							_g_free0 (_tmp48_);
							result = FALSE;
							_g_object_unref0 (local_file);
							_g_object_unref0 (custom_local);
							_g_free0 (action_desc);
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
							return result;
						}
						_tmp52_ = local_file;
						_tmp53_ = duplicity_job_slash_home_me;
						if (!g_file_has_prefix (_tmp52_, _tmp53_)) {
							gboolean _tmp54_ = FALSE;
							if (deja_dup_in_testing_mode ()) {
								GFile* _tmp55_;
								gchar* _tmp56_;
								gchar* _tmp57_;
								const gchar* _tmp58_;
								_tmp55_ = local_file;
								_tmp56_ = g_file_get_path (_tmp55_);
								_tmp57_ = _tmp56_;
								_tmp58_ = g_get_tmp_dir ();
								_tmp54_ = g_str_has_prefix (_tmp57_, _tmp58_);
								_g_free0 (_tmp57_);
							} else {
								_tmp54_ = FALSE;
							}
							_tmp51_ = !_tmp54_;
						} else {
							_tmp51_ = FALSE;
						}
						if (_tmp51_) {
							self->priv->needs_root = TRUE;
						}
						{
							GFile* _tmp59_;
							_tmp59_ = local_file;
							g_file_make_directory_with_parents (_tmp59_, NULL, &_inner_error_);
							if (G_UNLIKELY (_inner_error_ != NULL)) {
								if (g_error_matches (_inner_error_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
									goto __catch7_g_io_error_exists;
								}
								goto __catch7_g_error;
							}
						}
						goto __finally7;
						__catch7_g_io_error_exists:
						{
							GError* e = NULL;
							e = _inner_error_;
							_inner_error_ = NULL;
							_g_error_free0 (e);
						}
						goto __finally7;
						__catch7_g_error:
						{
							GError* e = NULL;
							GError* _tmp60_;
							const gchar* _tmp61_;
							e = _inner_error_;
							_inner_error_ = NULL;
							_tmp60_ = e;
							_tmp61_ = _tmp60_->message;
							duplicity_job_show_error (self, _tmp61_, NULL);
							result = FALSE;
							_g_error_free0 (e);
							_g_object_unref0 (local_file);
							_g_object_unref0 (custom_local);
							_g_free0 (action_desc);
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
							return result;
						}
						__finally7:
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							gboolean _tmp62_ = FALSE;
							_g_object_unref0 (local_file);
							_g_object_unref0 (custom_local);
							_g_free0 (action_desc);
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return _tmp62_;
						}
						_tmp63_ = local_file;
						_tmp64_ = _g_object_ref0 (_tmp63_);
						_g_object_unref0 (custom_local);
						custom_local = _tmp64_;
						_tmp65_ = duplicity_job_slash;
						_tmp66_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
						_tmp67_ = _tmp66_;
						_tmp68_ = _tmp67_->data;
						_tmp69_ = g_file_get_relative_path (_tmp65_, (GFile*) _tmp68_);
						rel_file_path = _tmp69_;
						_tmp70_ = rel_file_path;
						_tmp71_ = g_strdup_printf ("--file-to-restore=%s", _tmp70_);
						extra_argv = g_list_append (extra_argv, _tmp71_);
						_g_free0 (rel_file_path);
						_g_object_unref0 (local_file);
					} else {
						gboolean _tmp72_ = FALSE;
						gboolean _tmp73_;
						_tmp73_ = self->priv->has_non_home_contents;
						if (_tmp73_) {
							GFile* _tmp74_;
							GFile* _tmp75_;
							GFile* _tmp76_;
							_tmp74_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
							_tmp75_ = _tmp74_;
							_tmp76_ = duplicity_job_slash_home_me;
							_tmp72_ = !g_file_has_prefix (_tmp75_, _tmp76_);
						} else {
							_tmp72_ = FALSE;
						}
						if (_tmp72_) {
							self->priv->needs_root = TRUE;
						}
					}
					g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
				}
			}
			break;
		}
		default:
		break;
	}
	_tmp77_ = action_desc;
	if (_tmp77_ == NULL) {
		DejaDupToolJobMode _tmp78_;
		DejaDupToolJobMode _tmp79_;
		gchar* _tmp80_;
		_tmp78_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
		_tmp79_ = _tmp78_;
		_tmp80_ = deja_dup_operation_mode_to_string (_tmp79_);
		_g_free0 (action_desc);
		action_desc = _tmp80_;
	}
	_tmp81_ = action_desc;
	duplicity_job_set_status (self, _tmp81_, TRUE);
	_tmp82_ = extra_argv;
	_tmp83_ = custom_local;
	duplicity_job_connect_and_start (self, _tmp82_, NULL, NULL, _tmp83_);
	result = TRUE;
	_g_object_unref0 (custom_local);
	_g_free0 (action_desc);
	(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
	return result;
}


static GFile*
duplicity_job_make_local_rel_path (DuplicityJob* self,
                                   GFile* file)
{
	GFile* result = NULL;
	gchar* rel_file_path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = duplicity_job_slash;
	_tmp1_ = g_file_get_relative_path (_tmp0_, file);
	rel_file_path = _tmp1_;
	_tmp2_ = rel_file_path;
	if (_tmp2_ == NULL) {
		result = NULL;
		_g_free0 (rel_file_path);
		return result;
	}
	_tmp3_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = rel_file_path;
	_tmp6_ = g_file_resolve_relative_path (_tmp4_, _tmp5_);
	result = _tmp6_;
	_g_free0 (rel_file_path);
	return result;
}


static void
duplicity_job_check_backup_space_data_free (gpointer _data)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DuplicityJobCheckBackupSpaceData, _data_);
}


static void
duplicity_job_check_backup_space (DuplicityJob* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	DuplicityJob* _tmp0_;
	_data_ = g_slice_new0 (DuplicityJobCheckBackupSpaceData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_check_backup_space_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	duplicity_job_check_backup_space_co (_data_);
}


static void
duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                         GAsyncResult* _res_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void
duplicity_job_check_backup_space_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	duplicity_job_check_backup_space_co (_data_);
}


static gboolean
duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->self->priv->checked_backup_space = TRUE;
	_data_->_tmp0_ = _data_->self->priv->has_progress_total;
	if (!_data_->_tmp0_) {
		if (!duplicity_job_restart (_data_->self)) {
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
		}
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp1_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_state_ = 1;
	deja_dup_backend_get_space (_data_->_tmp2_, TRUE, duplicity_job_check_backup_space_ready, _data_);
	return FALSE;
	_state_1:
	_data_->free = deja_dup_backend_get_space_finish (_data_->_tmp2_, _data_->_res_);
	_data_->_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->_state_ = 2;
	deja_dup_backend_get_space (_data_->_tmp4_, FALSE, duplicity_job_check_backup_space_ready, _data_);
	return FALSE;
	_state_2:
	_data_->total = deja_dup_backend_get_space_finish (_data_->_tmp4_, _data_->_res_);
	_data_->_tmp6_ = _data_->free;
	_data_->_tmp7_ = deja_dup_backend_INFINITE_SPACE;
	if (_data_->_tmp6_ != _data_->_tmp7_) {
		_data_->_tmp8_ = _data_->free;
		_data_->_tmp9_ = _data_->total;
		_data_->_tmp5_ = _data_->_tmp8_ > _data_->_tmp9_;
	} else {
		_data_->_tmp5_ = FALSE;
	}
	if (_data_->_tmp5_) {
		_data_->_tmp10_ = _data_->free;
		_data_->total = _data_->_tmp10_;
	}
	_data_->_tmp11_ = _data_->total;
	_data_->_tmp12_ = _data_->self->priv->progress_total;
	if (_data_->_tmp11_ < _data_->_tmp12_) {
		duplicity_job_show_error (_data_->self, _ ("Backup location is too small.  Try using one with more space."), NULL);
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (g_task_get_completed (_data_->_async_result) != TRUE) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp13_ = _data_->free;
	_data_->_tmp14_ = _data_->self->priv->progress_total;
	if (_data_->_tmp13_ < _data_->_tmp14_) {
		_data_->_tmp15_ = _data_->self->priv->got_collection_info;
		if (_data_->_tmp15_) {
			_data_->full_dates = 0;
			_data_->_tmp16_ = _data_->self->priv->collection_info;
			{
				_data_->info_collection = _data_->_tmp16_;
				for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
					_data_->info = *((DuplicityJobDateInfo*) _data_->info_it->data);
					{
						_data_->_tmp17_ = _data_->info;
						_data_->_tmp18_ = _data_->_tmp17_.full;
						if (_data_->_tmp18_) {
							_data_->_tmp19_ = _data_->full_dates;
							_data_->full_dates = _data_->_tmp19_ + 1;
						}
					}
				}
			}
			_data_->_tmp20_ = _data_->full_dates;
			if (_data_->_tmp20_ > 1) {
				_data_->_tmp21_ = _data_->full_dates;
				duplicity_job_delete_excess (_data_->self, _data_->_tmp21_ - 1);
				_data_->self->priv->checked_backup_space = FALSE;
				_data_->self->priv->checked_collection_info = FALSE;
				_data_->self->priv->got_collection_info = FALSE;
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
				if (_data_->_state_ != 0) {
					while (g_task_get_completed (_data_->_async_result) != TRUE) {
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
					}
				}
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		} else {
			duplicity_job_show_error (_data_->self, _ ("Backup location does not have enough free space."), NULL);
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (g_task_get_completed (_data_->_async_result) != TRUE) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	if (!duplicity_job_restart (_data_->self)) {
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE, NULL);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gboolean
duplicity_job_cleanup (DuplicityJob* self)
{
	gboolean result = FALSE;
	DuplicityJobState _tmp0_;
	GList* cleanup_argv = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GList* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	if (_tmp0_ == DUPLICITY_JOB_STATE_CLEANUP) {
		result = FALSE;
		return result;
	}
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_CLEANUP);
	cleanup_argv = NULL;
	_tmp1_ = g_strdup ("cleanup");
	cleanup_argv = g_list_append (cleanup_argv, _tmp1_);
	_tmp2_ = g_strdup ("--force");
	cleanup_argv = g_list_append (cleanup_argv, _tmp2_);
	_tmp3_ = duplicity_job_get_remote (self);
	cleanup_argv = g_list_append (cleanup_argv, _tmp3_);
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
	_tmp4_ = cleanup_argv;
	duplicity_job_connect_and_start (self, NULL, NULL, _tmp4_, NULL);
	result = TRUE;
	(cleanup_argv == NULL) ? NULL : (cleanup_argv = (_g_list_free__g_free0_ (cleanup_argv), NULL));
	return result;
}


static void
duplicity_job_delete_excess (DuplicityJob* self,
                             gint cutoff)
{
	GList* argv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DELETE);
	argv = NULL;
	_tmp0_ = g_strdup ("remove-all-but-n-full");
	argv = g_list_append (argv, _tmp0_);
	_tmp1_ = g_strdup_printf ("%d", cutoff);
	argv = g_list_append (argv, _tmp1_);
	_tmp2_ = g_strdup ("--force");
	argv = g_list_append (argv, _tmp2_);
	_tmp3_ = duplicity_job_get_remote (self);
	argv = g_list_append (argv, _tmp3_);
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
	duplicity_job_connect_and_start (self, NULL, NULL, argv, NULL);
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
	return;
}


static gboolean
duplicity_job_can_ignore_error (DuplicityJob* self)
{
	gboolean result = FALSE;
	DuplicityJobState _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	result = _tmp0_ == DUPLICITY_JOB_STATE_CLEANUP;
	return result;
}


static void
duplicity_job_handle_done (DuplicityJob* self,
                           DuplicityInstance* inst,
                           gboolean success,
                           gboolean cancelled)
{
	gchar* detail = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp60_;
	gboolean _tmp61_ = FALSE;
	gboolean _tmp62_ = FALSE;
	const gchar* _tmp64_;
	g_return_if_fail (self != NULL);
	detail = NULL;
	if (duplicity_job_can_ignore_error (self)) {
		success = TRUE;
	}
	if (!cancelled) {
		_tmp0_ = success;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		DuplicityJobState _tmp1_;
		_tmp1_ = self->priv->_state;
		switch (_tmp1_) {
			case DUPLICITY_JOB_STATE_DRY_RUN:
			{
				guint64 _tmp2_;
				self->priv->has_progress_total = TRUE;
				_tmp2_ = self->priv->progress_count;
				self->priv->progress_total = _tmp2_;
				if (duplicity_job_restart (self)) {
					_g_free0 (detail);
					return;
				}
				break;
			}
			case DUPLICITY_JOB_STATE_DELETE:
			{
				if (duplicity_job_restart (self)) {
					_g_free0 (detail);
					return;
				}
				break;
			}
			case DUPLICITY_JOB_STATE_CLEANUP:
			{
				self->priv->cleaned_up_once = TRUE;
				if (duplicity_job_restart (self)) {
					_g_free0 (detail);
					return;
				}
				success = FALSE;
				cancelled = TRUE;
				break;
			}
			case DUPLICITY_JOB_STATE_STATUS:
			{
				gboolean should_restart = FALSE;
				DejaDupToolJobMode _tmp3_;
				DejaDupToolJobMode _tmp4_;
				DejaDupToolJobMode _tmp5_;
				DejaDupToolJobMode _tmp6_;
				gboolean _tmp7_ = FALSE;
				DejaDupToolJobMode _tmp8_;
				DejaDupToolJobMode _tmp9_;
				gboolean _tmp19_;
				self->priv->checked_collection_info = TRUE;
				_tmp3_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp4_ = _tmp3_;
				_tmp5_ = self->priv->_original_mode;
				should_restart = _tmp4_ != _tmp5_;
				_tmp6_ = self->priv->_original_mode;
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp6_);
				_tmp8_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp9_ = _tmp8_;
				if (_tmp9_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
					gboolean _tmp10_;
					_tmp10_ = self->priv->got_collection_info;
					_tmp7_ = _tmp10_;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					GDate threshold = {0};
					GDate _tmp11_ = {0};
					GDate full_backup = {0};
					GList* _tmp12_;
					gboolean _tmp17_ = FALSE;
					deja_dup_get_full_backup_threshold_date (&_tmp11_);
					threshold = _tmp11_;
					memset (&full_backup, 0, sizeof (GDate));
					_tmp12_ = self->priv->collection_info;
					{
						GList* info_collection = NULL;
						GList* info_it = NULL;
						info_collection = _tmp12_;
						for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
							DuplicityJobDateInfo info = {0};
							info = *((DuplicityJobDateInfo*) info_it->data);
							{
								DuplicityJobDateInfo _tmp13_;
								gboolean _tmp14_;
								_tmp13_ = info;
								_tmp14_ = _tmp13_.full;
								if (_tmp14_) {
									DuplicityJobDateInfo _tmp15_;
									GTimeVal _tmp16_;
									_tmp15_ = info;
									_tmp16_ = _tmp15_.time;
									g_date_set_time_val (&full_backup, &_tmp16_);
								}
							}
						}
					}
					if (!g_date_valid (&full_backup)) {
						_tmp17_ = TRUE;
					} else {
						GDate _tmp18_;
						_tmp18_ = full_backup;
						_tmp17_ = g_date_compare (&threshold, &_tmp18_) > 0;
					}
					if (_tmp17_) {
						self->priv->is_full_backup = TRUE;
						g_signal_emit_by_name ((DejaDupToolJob*) self, "is-full", !g_date_valid (&full_backup));
					}
				}
				_tmp19_ = should_restart;
				if (_tmp19_) {
					if (duplicity_job_restart (self)) {
						_g_free0 (detail);
						return;
					}
				}
				break;
			}
			case DUPLICITY_JOB_STATE_CHECK_CONTENTS:
			{
				DejaDupToolJobMode _tmp20_;
				self->priv->has_checked_contents = TRUE;
				_tmp20_ = self->priv->_original_mode;
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp20_);
				if (duplicity_job_restart (self)) {
					_g_free0 (detail);
					return;
				}
				break;
			}
			case DUPLICITY_JOB_STATE_NORMAL:
			{
				gboolean _tmp21_ = FALSE;
				DejaDupToolJobMode _tmp22_;
				DejaDupToolJobMode _tmp23_;
				DejaDupToolJobMode _tmp29_;
				DejaDupToolJobMode _tmp30_;
				_tmp22_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp23_ = _tmp22_;
				if (_tmp23_ == DEJA_DUP_TOOL_JOB_MODE_RESTORE) {
					GList* _tmp24_;
					GList* _tmp25_;
					_tmp24_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
					_tmp25_ = _tmp24_;
					_tmp21_ = _tmp25_ != NULL;
				} else {
					_tmp21_ = FALSE;
				}
				if (_tmp21_) {
					GList* _tmp26_;
					GList* _tmp27_;
					GList* _tmp28_;
					_tmp26_ = ((DejaDupToolJob*) self)->_restore_files;
					((DejaDupToolJob*) self)->_restore_files = g_list_delete_link (((DejaDupToolJob*) self)->_restore_files, _tmp26_);
					_tmp27_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
					_tmp28_ = _tmp27_;
					if (_tmp28_ != NULL) {
						if (duplicity_job_restart (self)) {
							_g_free0 (detail);
							return;
						}
					}
				}
				_tmp29_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp30_ = _tmp29_;
				if (_tmp30_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
					GList* _tmp31_;
					_tmp31_ = self->priv->local_error_files;
					if (_tmp31_ != NULL) {
						gchar* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						GList* _tmp35_;
						_tmp32_ = g_strdup (_ ("Could not back up the following files.  Please make sure you are able " \
"to open them."));
						_g_free0 (detail);
						detail = _tmp32_;
						_tmp33_ = detail;
						_tmp34_ = g_strconcat (_tmp33_, "\n", NULL);
						_g_free0 (detail);
						detail = _tmp34_;
						_tmp35_ = self->priv->local_error_files;
						{
							GList* f_collection = NULL;
							GList* f_it = NULL;
							f_collection = _tmp35_;
							for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
								GFile* _tmp36_;
								GFile* f = NULL;
								_tmp36_ = _g_object_ref0 ((GFile*) f_it->data);
								f = _tmp36_;
								{
									const gchar* _tmp37_;
									GFile* _tmp38_;
									gchar* _tmp39_;
									gchar* _tmp40_;
									gchar* _tmp41_;
									gchar* _tmp42_;
									gchar* _tmp43_;
									_tmp37_ = detail;
									_tmp38_ = f;
									_tmp39_ = g_file_get_parse_name (_tmp38_);
									_tmp40_ = _tmp39_;
									_tmp41_ = g_strdup_printf ("\n%s", _tmp40_);
									_tmp42_ = _tmp41_;
									_tmp43_ = g_strconcat (_tmp37_, _tmp42_, NULL);
									_g_free0 (detail);
									detail = _tmp43_;
									_g_free0 (_tmp42_);
									_g_free0 (_tmp40_);
									_g_object_unref0 (f);
								}
							}
						}
					}
					deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
					if (duplicity_job_delete_files_if_needed (self)) {
						_g_free0 (detail);
						return;
					}
				} else {
					DejaDupToolJobMode _tmp44_;
					DejaDupToolJobMode _tmp45_;
					_tmp44_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
					_tmp45_ = _tmp44_;
					if (_tmp45_ == DEJA_DUP_TOOL_JOB_MODE_RESTORE) {
						GList* _tmp46_;
						_tmp46_ = self->priv->local_error_files;
						if (_tmp46_ != NULL) {
							gchar* _tmp47_;
							const gchar* _tmp48_;
							gchar* _tmp49_;
							GList* _tmp50_;
							_tmp47_ = g_strdup (_ ("Could not restore the following files.  Please make sure you are able " \
"to write to them."));
							_g_free0 (detail);
							detail = _tmp47_;
							_tmp48_ = detail;
							_tmp49_ = g_strconcat (_tmp48_, "\n", NULL);
							_g_free0 (detail);
							detail = _tmp49_;
							_tmp50_ = self->priv->local_error_files;
							{
								GList* f_collection = NULL;
								GList* f_it = NULL;
								f_collection = _tmp50_;
								for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
									GFile* _tmp51_;
									GFile* f = NULL;
									_tmp51_ = _g_object_ref0 ((GFile*) f_it->data);
									f = _tmp51_;
									{
										const gchar* _tmp52_;
										GFile* _tmp53_;
										gchar* _tmp54_;
										gchar* _tmp55_;
										gchar* _tmp56_;
										gchar* _tmp57_;
										gchar* _tmp58_;
										_tmp52_ = detail;
										_tmp53_ = f;
										_tmp54_ = g_file_get_parse_name (_tmp53_);
										_tmp55_ = _tmp54_;
										_tmp56_ = g_strdup_printf ("\n%s", _tmp55_);
										_tmp57_ = _tmp56_;
										_tmp58_ = g_strconcat (_tmp52_, _tmp57_, NULL);
										_g_free0 (detail);
										detail = _tmp58_;
										_g_free0 (_tmp57_);
										_g_free0 (_tmp55_);
										_g_object_unref0 (f);
									}
								}
							}
						}
					}
				}
				break;
			}
			default:
			break;
		}
	} else {
		gboolean _tmp59_;
		_tmp59_ = self->priv->_was_stopped;
		if (_tmp59_) {
			success = TRUE;
		}
	}
	_tmp60_ = self->priv->_error_issued;
	if (_tmp60_) {
		success = FALSE;
	}
	if (!success) {
		_tmp62_ = !cancelled;
	} else {
		_tmp62_ = FALSE;
	}
	if (_tmp62_) {
		gboolean _tmp63_;
		_tmp63_ = self->priv->_error_issued;
		_tmp61_ = !_tmp63_;
	} else {
		_tmp61_ = FALSE;
	}
	if (_tmp61_) {
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), NULL);
	}
	inst = NULL;
	_tmp64_ = detail;
	g_signal_emit_by_name ((DejaDupToolJob*) self, "done", success, cancelled, _tmp64_);
	_g_free0 (detail);
}


static void
duplicity_job_set_status (DuplicityJob* self,
                          const gchar* msg,
                          gboolean save)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	if (save) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (msg);
		_g_free0 (self->priv->saved_status);
		self->priv->saved_status = _tmp0_;
		_g_object_unref0 (self->priv->saved_status_file);
		self->priv->saved_status_file = NULL;
	}
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-desc-changed", msg);
}


static void
duplicity_job_set_status_file (DuplicityJob* self,
                               GFile* file,
                               gboolean action,
                               gboolean save)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	if (save) {
		GFile* _tmp0_;
		_g_free0 (self->priv->saved_status);
		self->priv->saved_status = NULL;
		_tmp0_ = _g_object_ref0 (file);
		_g_object_unref0 (self->priv->saved_status_file);
		self->priv->saved_status_file = _tmp0_;
		self->priv->saved_status_file_action = action;
	}
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-file-changed", file, action);
}


static void
duplicity_job_set_saved_status (DuplicityJob* self)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->saved_status;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->saved_status;
		duplicity_job_set_status (self, _tmp1_, FALSE);
	} else {
		GFile* _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = self->priv->saved_status_file;
		_tmp3_ = self->priv->saved_status_file_action;
		duplicity_job_set_status_file (self, _tmp2_, _tmp3_, FALSE);
	}
}


static gboolean
duplicity_job_delete_files_if_needed (DuplicityJob* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->delete_age;
	if (_tmp0_ == 0) {
		self->priv->deleted_files = TRUE;
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->got_collection_info;
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->deleted_files;
		_tmp1_ = !_tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gint full_dates = 0;
		GTimeVal prev_time = {0};
		GDate prev_date = {0};
		gint too_old = 0;
		GTimeVal now = {0};
		GDate today = {0};
		GTimeVal _tmp4_;
		GList* _tmp5_;
		GTimeVal _tmp16_;
		GDate _tmp17_;
		gint _tmp18_;
		gboolean _tmp20_;
		gboolean _tmp22_ = FALSE;
		gint _tmp23_;
		full_dates = 0;
		g_get_current_time (&prev_time);
		memset (&prev_date, 0, sizeof (GDate));
		too_old = 0;
		g_get_current_time (&now);
		g_get_current_time (&now);
		memset (&today, 0, sizeof (GDate));
		_tmp4_ = now;
		g_date_set_time_val (&today, &_tmp4_);
		_tmp5_ = self->priv->collection_info;
		{
			GList* info_collection = NULL;
			GList* info_it = NULL;
			info_collection = _tmp5_;
			for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
				DuplicityJobDateInfo info = {0};
				info = *((DuplicityJobDateInfo*) info_it->data);
				{
					DuplicityJobDateInfo _tmp6_;
					gboolean _tmp7_;
					DuplicityJobDateInfo _tmp14_;
					GTimeVal _tmp15_;
					_tmp6_ = info;
					_tmp7_ = _tmp6_.full;
					if (_tmp7_) {
						gint _tmp8_;
						gint _tmp13_;
						_tmp8_ = full_dates;
						if (_tmp8_ > 0) {
							GTimeVal _tmp9_;
							GDate _tmp10_;
							gint _tmp11_;
							_tmp9_ = prev_time;
							g_date_set_time_val (&prev_date, &_tmp9_);
							_tmp10_ = today;
							_tmp11_ = self->priv->delete_age;
							if (g_date_days_between (&prev_date, &_tmp10_) > _tmp11_) {
								gint _tmp12_;
								_tmp12_ = too_old;
								too_old = _tmp12_ + 1;
							}
						}
						_tmp13_ = full_dates;
						full_dates = _tmp13_ + 1;
					}
					_tmp14_ = info;
					_tmp15_ = _tmp14_.time;
					prev_time = _tmp15_;
				}
			}
		}
		_tmp16_ = prev_time;
		g_date_set_time_val (&prev_date, &_tmp16_);
		_tmp17_ = today;
		_tmp18_ = self->priv->delete_age;
		if (g_date_days_between (&prev_date, &_tmp17_) > _tmp18_) {
			gint _tmp19_;
			_tmp19_ = too_old;
			too_old = _tmp19_ + 1;
		}
		_tmp20_ = self->priv->is_full_backup;
		if (_tmp20_) {
			gint _tmp21_;
			_tmp21_ = full_dates;
			full_dates = _tmp21_ + 1;
		}
		_tmp23_ = too_old;
		if (_tmp23_ > 0) {
			gint _tmp24_;
			_tmp24_ = full_dates;
			_tmp22_ = _tmp24_ > DUPLICITY_JOB_MINIMUM_FULL;
		} else {
			_tmp22_ = FALSE;
		}
		if (_tmp22_) {
			gint cutoff = 0;
			gint _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
			_tmp25_ = full_dates;
			_tmp26_ = too_old;
			cutoff = MAX (DUPLICITY_JOB_MINIMUM_FULL, _tmp25_ - _tmp26_);
			_tmp27_ = cutoff;
			duplicity_job_delete_excess (self, _tmp27_);
			result = TRUE;
			return result;
		}
		self->priv->deleted_files = TRUE;
		result = FALSE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


static void
duplicity_job_delete_cache (DuplicityJob* self)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* cachedir = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	DejaDupRecursiveDelete* del = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	DejaDupRecursiveDelete* _tmp8_;
	DejaDupRecursiveDelete* _tmp9_;
	DejaDupRecursiveDelete* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	dir = _tmp1_;
	_tmp2_ = dir;
	if (_tmp2_ == NULL) {
		_g_free0 (dir);
		return;
	}
	_tmp3_ = dir;
	_tmp4_ = g_build_filename (_tmp3_, PACKAGE, NULL);
	cachedir = _tmp4_;
	_tmp5_ = cachedir;
	_tmp6_ = g_file_new_for_path (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = deja_dup_recursive_delete_new (_tmp7_, "metadata");
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp7_);
	del = _tmp9_;
	_tmp10_ = del;
	deja_dup_recursive_op_start ((DejaDupRecursiveOp*) _tmp10_);
	_g_object_unref0 (del);
	_g_free0 (cachedir);
	_g_free0 (dir);
}


static gboolean
duplicity_job_restart_without_cache (DuplicityJob* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->restarted_without_cache;
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	self->priv->restarted_without_cache = TRUE;
	duplicity_job_delete_cache (self);
	result = duplicity_job_restart (self);
	return result;
}


static void
duplicity_job_handle_exit (DuplicityJob* self,
                           gint code)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (code == DUPLICITY_JOB_ERROR_GENERIC) {
		gboolean _tmp1_;
		_tmp1_ = self->priv->_error_issued;
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		duplicity_job_restart_without_cache (self);
	}
}


static void
duplicity_job_handle_message (DuplicityJob* self,
                              DuplicityInstance* inst,
                              gchar** control_line,
                              int control_line_length1,
                              GList* data_lines,
                              const gchar* user_text)
{
	gchar* keyword = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	static GQuark _tmp4_label2 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (inst != NULL);
	g_return_if_fail (user_text != NULL);
	if (control_line_length1 == 0) {
		return;
	}
	_tmp0_ = control_line[0];
	_tmp1_ = g_strdup (_tmp0_);
	keyword = _tmp1_;
	_tmp2_ = keyword;
	_tmp3_ = _tmp2_;
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("ERROR")))) {
		switch (0) {
			default:
			{
				duplicity_job_process_error (self, control_line, control_line_length1, data_lines, user_text);
				break;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("INFO")))) {
		switch (0) {
			default:
			{
				duplicity_job_process_info (self, control_line, control_line_length1, data_lines, user_text);
				break;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("WARNING")))) {
		switch (0) {
			default:
			{
				duplicity_job_process_warning (self, control_line, control_line_length1, data_lines, user_text);
				break;
			}
		}
	}
	_g_free0 (keyword);
}


static gboolean
duplicity_job_ask_question (DuplicityJob* self,
                            const gchar* t,
                            const gchar* m)
{
	gboolean result = FALSE;
	gboolean rv = FALSE;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (t != NULL, FALSE);
	g_return_val_if_fail (m != NULL, FALSE);
	duplicity_job_disconnect_inst (self);
	g_signal_emit_by_name ((DejaDupToolJob*) self, "question", t, m);
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	rv = _tmp1_ != DEJA_DUP_TOOL_JOB_MODE_INVALID;
	_tmp2_ = rv;
	if (!_tmp2_) {
		duplicity_job_handle_done (self, NULL, FALSE, TRUE);
	}
	result = rv;
	return result;
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


static gchar*
duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                    const gchar* file,
                                    gint skip_bits)
{
	gchar* result = NULL;
	gint next = 0;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	next = 0;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
		gint _tmp3_;
		_tmp1_ = skip_bits;
		skip_bits = _tmp1_ - 1;
		if (_tmp1_ > 0) {
			gint _tmp2_;
			_tmp2_ = next;
			_tmp0_ = _tmp2_ >= 0;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp3_ = next;
		next = string_index_of_char (file, (gunichar) '.', _tmp3_) + 1;
	}
	_tmp4_ = next;
	if (_tmp4_ < 0) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		result = _tmp5_;
		return result;
	} else {
		gint _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = next;
		_tmp7_ = string_substring (file, (glong) _tmp6_, (glong) -1);
		result = _tmp7_;
		return result;
	}
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static void
duplicity_job_real_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  int firstline_length1,
                                  GList* data,
                                  const gchar* text_in)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp76_;
	g_return_if_fail (text_in != NULL);
	_tmp0_ = g_strdup (text_in);
	text = _tmp0_;
	if (duplicity_job_can_ignore_error (self)) {
		_g_free0 (text);
		return;
	}
	if (firstline_length1 > 1) {
		const gchar* _tmp1_;
		_tmp1_ = firstline[1];
		switch (atoi (_tmp1_)) {
			case DUPLICITY_JOB_ERROR_EXCEPTION:
			{
				const gchar* _tmp2_ = NULL;
				const gchar* _tmp4_;
				if (firstline_length1 > 2) {
					const gchar* _tmp3_;
					_tmp3_ = firstline[2];
					_tmp2_ = _tmp3_;
				} else {
					_tmp2_ = "";
				}
				_tmp4_ = text;
				duplicity_job_process_exception (self, _tmp2_, _tmp4_);
				_g_free0 (text);
				return;
			}
			case DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND:
			{
				GList* _tmp5_;
				GList* _tmp6_;
				_tmp5_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
				_tmp6_ = _tmp5_;
				if (_tmp6_ != NULL) {
					GList* _tmp7_;
					GList* _tmp8_;
					gconstpointer _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					_tmp7_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
					_tmp8_ = _tmp7_;
					_tmp9_ = _tmp8_->data;
					_tmp10_ = g_file_get_parse_name ((GFile*) _tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = g_strdup_printf (_ ("Could not restore ‘%s’: File not found in backup"), _tmp11_);
					_g_free0 (text);
					text = _tmp12_;
					_g_free0 (_tmp11_);
				}
				break;
			}
			case DUPLICITY_JOB_ERROR_GPG:
			{
				gchar* bad_key_msg = NULL;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				_tmp13_ = gpg_strerror (GPG_ERR_BAD_KEY);
				_tmp14_ = g_strdup (_tmp13_);
				bad_key_msg = _tmp14_;
				_tmp15_ = bad_key_msg;
				if (string_contains (text_in, _tmp15_)) {
					gchar* _tmp16_;
					g_signal_emit_by_name ((DejaDupToolJob*) self, "bad-encryption-password");
					_tmp16_ = g_strdup (_ ("Bad encryption password."));
					_g_free0 (text);
					text = _tmp16_;
				}
				_g_free0 (bad_key_msg);
				break;
			}
			case DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED:
			{
				gchar* _tmp22_;
				if (firstline_length1 >= 4) {
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gboolean _tmp21_;
					_tmp17_ = firstline[3];
					_tmp18_ = firstline[2];
					_tmp19_ = g_strdup_printf (_ ("The existing backup is of a computer named %s, but the current compute" \
"r’s name is %s.  If this is unexpected, you should back up to a differ" \
"ent location."), _tmp17_, _tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = !duplicity_job_ask_question (self, _ ("Computer name changed"), _tmp20_);
					_g_free0 (_tmp20_);
					if (_tmp21_) {
						_g_free0 (text);
						return;
					}
				}
				_tmp22_ = g_strdup ("--allow-source-mismatch");
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp22_);
				if (duplicity_job_restart (self)) {
					_g_free0 (text);
					return;
				}
				break;
			}
			case DUPLICITY_JOB_ERROR_BAD_VOLUME:
			{
				DejaDupToolJobMode _tmp23_;
				DejaDupToolJobMode _tmp24_;
				_tmp23_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp24_ = _tmp23_;
				if (_tmp24_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
					gchar* this_volume = NULL;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gboolean _tmp31_ = FALSE;
					gboolean _tmp32_ = FALSE;
					guint _tmp33_;
					_tmp25_ = firstline[2];
					_tmp26_ = duplicity_job_parse_duplicity_file (self, _tmp25_, 2);
					this_volume = _tmp26_;
					_tmp27_ = self->priv->last_bad_volume;
					_tmp28_ = this_volume;
					if (g_strcmp0 (_tmp27_, _tmp28_) != 0) {
						const gchar* _tmp29_;
						gchar* _tmp30_;
						self->priv->bad_volume_count = (guint) 0;
						_tmp29_ = this_volume;
						_tmp30_ = g_strdup (_tmp29_);
						_g_free0 (self->priv->last_bad_volume);
						self->priv->last_bad_volume = _tmp30_;
					}
					_tmp33_ = self->priv->bad_volume_count;
					if (_tmp33_ == ((guint) 0)) {
						_tmp32_ = duplicity_job_restart (self);
					} else {
						_tmp32_ = FALSE;
					}
					if (_tmp32_) {
						_tmp31_ = TRUE;
					} else {
						gboolean _tmp34_ = FALSE;
						guint _tmp35_;
						_tmp35_ = self->priv->bad_volume_count;
						if (_tmp35_ == ((guint) 1)) {
							_tmp34_ = duplicity_job_cleanup (self);
						} else {
							_tmp34_ = FALSE;
						}
						_tmp31_ = _tmp34_;
					}
					if (_tmp31_) {
						guint _tmp36_;
						_tmp36_ = self->priv->bad_volume_count;
						self->priv->bad_volume_count = _tmp36_ + 1;
						_g_free0 (this_volume);
						_g_free0 (text);
						return;
					}
					_g_free0 (this_volume);
				}
				break;
			}
			case DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED:
			{
				gboolean _tmp37_ = FALSE;
				gboolean _tmp45_ = FALSE;
				if (firstline_length1 >= 5) {
					const gchar* _tmp38_;
					_tmp38_ = firstline[2];
					_tmp37_ = g_strcmp0 (_tmp38_, "put") == 0;
				} else {
					_tmp37_ = FALSE;
				}
				if (_tmp37_) {
					GFile* file = NULL;
					const gchar* _tmp39_;
					GFile* _tmp40_;
					GFile* _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					gchar* _tmp44_;
					_tmp39_ = firstline[4];
					_tmp40_ = duplicity_job_make_file_obj (self, _tmp39_);
					file = _tmp40_;
					_tmp41_ = file;
					_tmp42_ = g_file_get_parse_name (_tmp41_);
					_tmp43_ = _tmp42_;
					_tmp44_ = g_strdup_printf (_ ("Permission denied when trying to create ‘%s’."), _tmp43_);
					_g_free0 (text);
					text = _tmp44_;
					_g_free0 (_tmp43_);
					_g_object_unref0 (file);
				}
				if (firstline_length1 >= 5) {
					const gchar* _tmp46_;
					_tmp46_ = firstline[2];
					_tmp45_ = g_strcmp0 (_tmp46_, "get") == 0;
				} else {
					_tmp45_ = FALSE;
				}
				if (_tmp45_) {
					GFile* file = NULL;
					const gchar* _tmp47_;
					GFile* _tmp48_;
					GFile* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					gchar* _tmp52_;
					_tmp47_ = firstline[3];
					_tmp48_ = duplicity_job_make_file_obj (self, _tmp47_);
					file = _tmp48_;
					_tmp49_ = file;
					_tmp50_ = g_file_get_parse_name (_tmp49_);
					_tmp51_ = _tmp50_;
					_tmp52_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp51_);
					_g_free0 (text);
					text = _tmp52_;
					_g_free0 (_tmp51_);
					_g_object_unref0 (file);
				} else {
					gboolean _tmp53_ = FALSE;
					if (firstline_length1 >= 4) {
						const gchar* _tmp54_;
						_tmp54_ = firstline[2];
						_tmp53_ = g_strcmp0 (_tmp54_, "list") == 0;
					} else {
						_tmp53_ = FALSE;
					}
					if (_tmp53_) {
						GFile* file = NULL;
						const gchar* _tmp55_;
						GFile* _tmp56_;
						GFile* _tmp57_;
						gchar* _tmp58_;
						gchar* _tmp59_;
						gchar* _tmp60_;
						_tmp55_ = firstline[3];
						_tmp56_ = duplicity_job_make_file_obj (self, _tmp55_);
						file = _tmp56_;
						_tmp57_ = file;
						_tmp58_ = g_file_get_parse_name (_tmp57_);
						_tmp59_ = _tmp58_;
						_tmp60_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp59_);
						_g_free0 (text);
						text = _tmp60_;
						_g_free0 (_tmp59_);
						_g_object_unref0 (file);
					} else {
						gboolean _tmp61_ = FALSE;
						if (firstline_length1 >= 4) {
							const gchar* _tmp62_;
							_tmp62_ = firstline[2];
							_tmp61_ = g_strcmp0 (_tmp62_, "delete") == 0;
						} else {
							_tmp61_ = FALSE;
						}
						if (_tmp61_) {
							GFile* file = NULL;
							const gchar* _tmp63_;
							GFile* _tmp64_;
							GFile* _tmp65_;
							gchar* _tmp66_;
							gchar* _tmp67_;
							gchar* _tmp68_;
							_tmp63_ = firstline[3];
							_tmp64_ = duplicity_job_make_file_obj (self, _tmp63_);
							file = _tmp64_;
							_tmp65_ = file;
							_tmp66_ = g_file_get_parse_name (_tmp65_);
							_tmp67_ = _tmp66_;
							_tmp68_ = g_strdup_printf (_ ("Permission denied when trying to delete ‘%s’."), _tmp67_);
							_g_free0 (text);
							text = _tmp68_;
							_g_free0 (_tmp67_);
							_g_object_unref0 (file);
						}
					}
				}
				break;
			}
			case DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND:
			{
				if (firstline_length1 >= 4) {
					GFile* file = NULL;
					const gchar* _tmp69_;
					GFile* _tmp70_;
					GFile* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
					gchar* _tmp74_;
					_tmp69_ = firstline[3];
					_tmp70_ = duplicity_job_make_file_obj (self, _tmp69_);
					file = _tmp70_;
					_tmp71_ = file;
					_tmp72_ = g_file_get_parse_name (_tmp71_);
					_tmp73_ = _tmp72_;
					_tmp74_ = g_strdup_printf (_ ("Backup location ‘%s’ does not exist."), _tmp73_);
					_g_free0 (text);
					text = _tmp74_;
					_g_free0 (_tmp73_);
					_g_object_unref0 (file);
				}
				break;
			}
			case DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE:
			{
				if (firstline_length1 >= 5) {
					gchar* _tmp75_;
					_tmp75_ = g_strdup (_ ("No space left."));
					_g_free0 (text);
					text = _tmp75_;
				}
				break;
			}
			default:
			break;
		}
	}
	_tmp76_ = text;
	duplicity_job_show_error (self, _tmp76_, NULL);
	_g_free0 (text);
}


void
duplicity_job_process_error (DuplicityJob* self,
                             gchar** firstline,
                             int firstline_length1,
                             GList* data,
                             const gchar* text_in)
{
	g_return_if_fail (self != NULL);
	DUPLICITY_JOB_GET_CLASS (self)->process_error (self, firstline, firstline_length1, data, text_in);
}


static void
duplicity_job_process_exception (DuplicityJob* self,
                                 const gchar* exception,
                                 const gchar* text)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (exception != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = exception;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("S3ResponseError")))) {
		switch (0) {
			default:
			{
				if (string_contains (text, "<Code>InvalidAccessKeyId</Code>")) {
					duplicity_job_show_error (self, _ ("Invalid ID."), NULL);
				} else {
					if (string_contains (text, "<Code>SignatureDoesNotMatch</Code>")) {
						duplicity_job_show_error (self, _ ("Invalid secret key."), NULL);
					} else {
						if (string_contains (text, "<Code>NotSignedUp</Code>")) {
							duplicity_job_show_error (self, _ ("Your Amazon Web Services account is not signed up for the S3 service."), NULL);
						}
					}
				}
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("S3CreateError")))) {
		switch (0) {
			default:
			{
				if (string_contains (text, "<Code>BucketAlreadyExists</Code>")) {
					DejaDupBackend* _tmp3_;
					DejaDupBackend* _tmp4_;
					_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
					_tmp4_ = _tmp3_;
					if (deja_dup_backend_s3_bump_bucket (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, DEJA_DUP_TYPE_BACKEND_S3, DejaDupBackendS3))) {
						if (duplicity_job_restart (self)) {
							return;
						}
					}
					duplicity_job_show_error (self, _ ("S3 bucket name is not available."), NULL);
				}
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("EOFError")))) {
		switch (0) {
			default:
			{
				g_signal_emit_by_name ((DejaDupToolJob*) self, "bad-encryption-password");
				duplicity_job_show_error (self, _ ("Bad encryption password."), NULL);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("IOError")))) {
		switch (0) {
			default:
			{
				if (string_contains (text, "GnuPG")) {
					duplicity_job_show_error (self, _ ("Bad encryption password."), NULL);
				} else {
					gboolean _tmp5_ = FALSE;
					if (string_contains (text, "[Errno 5]")) {
						GFile* _tmp6_;
						_tmp6_ = self->priv->last_touched_file;
						_tmp5_ = _tmp6_ != NULL;
					} else {
						_tmp5_ = FALSE;
					}
					if (_tmp5_) {
						DejaDupToolJobMode _tmp7_;
						DejaDupToolJobMode _tmp8_;
						_tmp7_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
						_tmp8_ = _tmp7_;
						if (_tmp8_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
							GFile* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
							_tmp9_ = self->priv->last_touched_file;
							_tmp10_ = g_file_get_parse_name (_tmp9_);
							_tmp11_ = _tmp10_;
							_tmp12_ = g_strdup_printf (_ ("Error reading file ‘%s’."), _tmp11_);
							_tmp13_ = _tmp12_;
							duplicity_job_show_error (self, _tmp13_, NULL);
							_g_free0 (_tmp13_);
							_g_free0 (_tmp11_);
						} else {
							GFile* _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
							gchar* _tmp17_;
							gchar* _tmp18_;
							_tmp14_ = self->priv->last_touched_file;
							_tmp15_ = g_file_get_parse_name (_tmp14_);
							_tmp16_ = _tmp15_;
							_tmp17_ = g_strdup_printf (_ ("Error writing file ‘%s’."), _tmp16_);
							_tmp18_ = _tmp17_;
							duplicity_job_show_error (self, _tmp18_, NULL);
							_g_free0 (_tmp18_);
							_g_free0 (_tmp16_);
						}
					} else {
						if (string_contains (text, "[Errno 28]")) {
							gchar* where = NULL;
							DejaDupToolJobMode _tmp19_;
							DejaDupToolJobMode _tmp20_;
							const gchar* _tmp27_;
							where = NULL;
							_tmp19_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
							_tmp20_ = _tmp19_;
							if (_tmp20_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
								DejaDupBackend* _tmp21_;
								DejaDupBackend* _tmp22_;
								gchar* _tmp23_;
								_tmp21_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
								_tmp22_ = _tmp21_;
								_tmp23_ = deja_dup_backend_get_location_pretty (_tmp22_);
								_g_free0 (where);
								where = _tmp23_;
							} else {
								GFile* _tmp24_;
								GFile* _tmp25_;
								gchar* _tmp26_;
								_tmp24_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
								_tmp25_ = _tmp24_;
								_tmp26_ = g_file_get_path (_tmp25_);
								_g_free0 (where);
								where = _tmp26_;
							}
							_tmp27_ = where;
							if (_tmp27_ == NULL) {
								duplicity_job_show_error (self, _ ("No space left."), NULL);
							} else {
								const gchar* _tmp28_;
								gchar* _tmp29_;
								gchar* _tmp30_;
								_tmp28_ = where;
								_tmp29_ = g_strdup_printf (_ ("No space left in ‘%s’."), _tmp28_);
								_tmp30_ = _tmp29_;
								duplicity_job_show_error (self, _tmp30_, NULL);
								_g_free0 (_tmp30_);
							}
							_g_free0 (where);
						} else {
							if (string_contains (text, "CRC check failed")) {
								if (duplicity_job_restart_without_cache (self)) {
									return;
								}
							}
						}
					}
				}
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("CollectionsError")))) {
		switch (0) {
			default:
			{
				duplicity_job_show_error (self, _ ("No backup files found"), NULL);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("AssertionError")))) {
		switch (0) {
			default:
			{
				if (duplicity_job_restart_without_cache (self)) {
					return;
				}
				break;
			}
		}
	}
	_tmp32_ = self->priv->_error_issued;
	if (!_tmp32_) {
		_tmp31_ = !duplicity_job_restart_without_cache (self);
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), text);
	}
}


static void
duplicity_job_real_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 int firstline_length1,
                                 GList* data,
                                 const gchar* text)
{
	g_return_if_fail (text != NULL);
	if (firstline_length1 > 1) {
		const gchar* _tmp0_;
		_tmp0_ = firstline[1];
		switch (atoi (_tmp0_)) {
			case DUPLICITY_JOB_INFO_DIFF_FILE_NEW:
			case DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED:
			case DUPLICITY_JOB_INFO_DIFF_FILE_DELETED:
			{
				if (firstline_length1 > 2) {
					const gchar* _tmp1_;
					_tmp1_ = firstline[2];
					duplicity_job_process_diff_file (self, _tmp1_);
				}
				break;
			}
			case DUPLICITY_JOB_INFO_PATCH_FILE_WRITING:
			case DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING:
			{
				if (firstline_length1 > 2) {
					const gchar* _tmp2_;
					_tmp2_ = firstline[2];
					duplicity_job_process_patch_file (self, _tmp2_);
				}
				break;
			}
			case DUPLICITY_JOB_INFO_PROGRESS:
			{
				duplicity_job_process_progress (self, firstline, firstline_length1);
				break;
			}
			case DUPLICITY_JOB_INFO_COLLECTION_STATUS:
			{
				duplicity_job_process_collection_status (self, data);
				break;
			}
			case DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN:
			case DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN:
			{
				DejaDupBackend* _tmp3_;
				DejaDupBackend* _tmp4_;
				_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
				_tmp4_ = _tmp3_;
				if (!deja_dup_backend_is_native (_tmp4_)) {
					duplicity_job_set_status (self, _ ("Uploading…"), TRUE);
				}
				break;
			}
			case DUPLICITY_JOB_INFO_FILE_STAT:
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				_tmp5_ = firstline[2];
				_tmp6_ = firstline[3];
				duplicity_job_process_file_stat (self, _tmp5_, _tmp6_, data, text);
				break;
			}
			default:
			break;
		}
	}
}


void
duplicity_job_process_info (DuplicityJob* self,
                            gchar** firstline,
                            int firstline_length1,
                            GList* data,
                            const gchar* text)
{
	g_return_if_fail (self != NULL);
	DUPLICITY_JOB_GET_CLASS (self)->process_info (self, firstline, firstline_length1, data, text);
}


static void
duplicity_job_process_file_stat (DuplicityJob* self,
                                 const gchar* date,
                                 const gchar* file,
                                 GList* data,
                                 const gchar* text)
{
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	DuplicityJobState _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (date != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != DEJA_DUP_TOOL_JOB_MODE_LIST) {
		return;
	}
	_tmp2_ = self->priv->_state;
	if (_tmp2_ == DUPLICITY_JOB_STATE_CHECK_CONTENTS) {
		GFile* gfile = NULL;
		GFile* _tmp3_;
		gboolean _tmp4_ = FALSE;
		GFile* _tmp5_;
		GFile* _tmp6_;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_;
		_tmp3_ = duplicity_job_make_file_obj (self, file);
		gfile = _tmp3_;
		_tmp5_ = gfile;
		_tmp6_ = duplicity_job_slash_root;
		if (g_file_equal (_tmp5_, _tmp6_)) {
			_tmp4_ = TRUE;
		} else {
			gboolean _tmp7_ = FALSE;
			GFile* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_;
			_tmp8_ = gfile;
			_tmp9_ = g_file_get_parent (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = _tmp10_ != NULL;
			_g_object_unref0 (_tmp10_);
			if (_tmp11_) {
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				_tmp12_ = gfile;
				_tmp13_ = g_file_get_parent (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = duplicity_job_slash_home;
				_tmp7_ = g_file_equal (_tmp14_, _tmp15_);
				_g_object_unref0 (_tmp14_);
			} else {
				_tmp7_ = FALSE;
			}
			_tmp4_ = _tmp7_;
		}
		if (_tmp4_) {
			GFile* _tmp16_;
			GFile* _tmp17_;
			_tmp16_ = gfile;
			_tmp17_ = _g_object_ref0 (_tmp16_);
			self->priv->homes = g_list_append (self->priv->homes, _tmp17_);
		}
		_tmp21_ = self->priv->has_non_home_contents;
		if (!_tmp21_) {
			GFile* _tmp22_;
			GFile* _tmp23_;
			_tmp22_ = gfile;
			_tmp23_ = duplicity_job_slash;
			_tmp20_ = !g_file_equal (_tmp22_, _tmp23_);
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			GFile* _tmp24_;
			GFile* _tmp25_;
			_tmp24_ = gfile;
			_tmp25_ = duplicity_job_slash_home;
			_tmp19_ = !g_file_equal (_tmp24_, _tmp25_);
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			GFile* _tmp26_;
			GFile* _tmp27_;
			_tmp26_ = gfile;
			_tmp27_ = duplicity_job_slash_home;
			_tmp18_ = !g_file_has_prefix (_tmp26_, _tmp27_);
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			self->priv->has_non_home_contents = TRUE;
		}
		_g_object_unref0 (gfile);
	}
	g_signal_emit_by_name ((DejaDupToolJob*) self, "listed-current-files", date, file);
}


static void
duplicity_job_process_diff_file (DuplicityJob* self,
                                 const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = duplicity_job_make_file_obj (self, file);
	gfile = _tmp0_;
	_tmp1_ = gfile;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->last_touched_file);
	self->priv->last_touched_file = _tmp2_;
	_tmp3_ = gfile;
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
		_tmp4_ = gfile;
		_tmp5_ = self->priv->_state;
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
	}
	_g_object_unref0 (gfile);
}


static void
duplicity_job_process_patch_file (DuplicityJob* self,
                                  const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = duplicity_job_make_file_obj (self, file);
	gfile = _tmp0_;
	_tmp1_ = gfile;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->last_touched_file);
	self->priv->last_touched_file = _tmp2_;
	_tmp3_ = gfile;
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
		_tmp4_ = gfile;
		_tmp5_ = self->priv->_state;
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
	}
	_g_object_unref0 (gfile);
}


static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
	guint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0ULL);
	_tmp0_ = g_ascii_strtoull (str, NULL, (guint) 0);
	result = _tmp0_;
	return result;
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	g_return_val_if_fail (str != NULL, 0.0);
	_tmp0_ = g_ascii_strtod (str, NULL);
	result = _tmp0_;
	return result;
}


static void
duplicity_job_process_progress (DuplicityJob* self,
                                gchar** firstline,
                                int firstline_length1)
{
	gdouble total = 0.0;
	gdouble percent = 0.0;
	guint64 _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	g_return_if_fail (self != NULL);
	if (firstline_length1 > 2) {
		const gchar* _tmp0_;
		_tmp0_ = firstline[2];
		self->priv->progress_count = uint64_parse (_tmp0_);
	} else {
		return;
	}
	if (firstline_length1 > 3) {
		const gchar* _tmp1_;
		_tmp1_ = firstline[3];
		total = double_parse (_tmp1_);
	} else {
		guint64 _tmp2_;
		_tmp2_ = self->priv->progress_total;
		if (_tmp2_ > ((guint64) 0)) {
			guint64 _tmp3_;
			_tmp3_ = self->priv->progress_total;
			total = (gdouble) _tmp3_;
		} else {
			return;
		}
	}
	_tmp4_ = self->priv->progress_count;
	_tmp5_ = total;
	percent = ((gdouble) _tmp4_) / _tmp5_;
	_tmp6_ = percent;
	if (_tmp6_ > ((gdouble) 1)) {
		percent = (gdouble) 1;
	}
	_tmp7_ = percent;
	if (_tmp7_ < ((gdouble) 0)) {
		percent = (gdouble) 0;
	}
	_tmp8_ = percent;
	g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", _tmp8_);
}


static GFile*
duplicity_job_make_file_obj (DuplicityJob* self,
                             const gchar* file)
{
	GFile* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = duplicity_job_slash;
	_tmp1_ = g_file_resolve_relative_path (_tmp0_, file);
	result = _tmp1_;
	return result;
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static gpointer
_duplicity_job_date_info_dup0 (gpointer self)
{
	return self ? duplicity_job_date_info_dup (self) : NULL;
}


static void
duplicity_job_process_collection_status (DuplicityJob* self,
                                         GList* lines)
{
	gboolean _tmp0_ = FALSE;
	DejaDupToolJobMode _tmp1_;
	DejaDupToolJobMode _tmp2_;
	GTimeVal timeval = {0};
	GList* dates = NULL;
	GList* infos = NULL;
	gboolean in_chain = FALSE;
	GList* _tmp36_;
	GList* _tmp39_;
	g_return_if_fail (self != NULL);
	_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != DEJA_DUP_TOOL_JOB_MODE_STATUS) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->priv->got_collection_info;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	g_get_current_time (&timeval);
	dates = NULL;
	infos = NULL;
	in_chain = FALSE;
	{
		GList* line_collection = NULL;
		GList* line_it = NULL;
		line_collection = lines;
		for (line_it = line_collection; line_it != NULL; line_it = line_it->next) {
			gchar* _tmp4_;
			gchar* line = NULL;
			_tmp4_ = g_strdup ((const gchar*) line_it->data);
			line = _tmp4_;
			{
				gboolean _tmp5_ = FALSE;
				const gchar* _tmp6_;
				_tmp6_ = line;
				if (g_strcmp0 (_tmp6_, "chain-complete") == 0) {
					_tmp5_ = TRUE;
				} else {
					const gchar* _tmp7_;
					_tmp7_ = line;
					_tmp5_ = string_index_of (_tmp7_, "chain-no-sig", 0) == 0;
				}
				if (_tmp5_) {
					in_chain = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					gboolean _tmp9_ = FALSE;
					gboolean _tmp10_;
					_tmp10_ = in_chain;
					if (_tmp10_) {
						const gchar* _tmp11_;
						gint _tmp12_;
						gint _tmp13_;
						_tmp11_ = line;
						_tmp12_ = strlen (_tmp11_);
						_tmp13_ = _tmp12_;
						_tmp9_ = _tmp13_ > 0;
					} else {
						_tmp9_ = FALSE;
					}
					if (_tmp9_) {
						const gchar* _tmp14_;
						_tmp14_ = line;
						_tmp8_ = string_get (_tmp14_, (glong) 0) == ' ';
					} else {
						_tmp8_ = FALSE;
					}
					if (_tmp8_) {
						gchar** tokens = NULL;
						const gchar* _tmp15_;
						gchar** _tmp16_;
						gchar** _tmp17_;
						gint tokens_length1;
						gint _tokens_size_;
						gboolean _tmp18_ = FALSE;
						gchar** _tmp19_;
						gint _tmp19__length1;
						_tmp15_ = line;
						_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, " ", 0);
						tokens = _tmp17_;
						tokens_length1 = _vala_array_length (_tmp16_);
						_tokens_size_ = tokens_length1;
						_tmp19_ = tokens;
						_tmp19__length1 = tokens_length1;
						if (_tmp19__length1 > 2) {
							gchar** _tmp20_;
							gint _tmp20__length1;
							const gchar* _tmp21_;
							_tmp20_ = tokens;
							_tmp20__length1 = tokens_length1;
							_tmp21_ = _tmp20_[2];
							_tmp18_ = g_time_val_from_iso8601 (_tmp21_, &timeval);
						} else {
							_tmp18_ = FALSE;
						}
						if (_tmp18_) {
							gchar** _tmp22_;
							gint _tmp22__length1;
							const gchar* _tmp23_;
							gchar* _tmp24_;
							DuplicityJobDateInfo info = {0};
							GTimeVal _tmp25_;
							gchar** _tmp26_;
							gint _tmp26__length1;
							const gchar* _tmp27_;
							DuplicityJobDateInfo _tmp28_;
							DuplicityJobDateInfo* _tmp29_;
							gboolean _tmp30_ = FALSE;
							gboolean _tmp31_;
							_tmp22_ = tokens;
							_tmp22__length1 = tokens_length1;
							_tmp23_ = _tmp22_[2];
							_tmp24_ = g_strdup (_tmp23_);
							dates = g_list_append (dates, _tmp24_);
							memset (&info, 0, sizeof (DuplicityJobDateInfo));
							_tmp25_ = timeval;
							info.time = _tmp25_;
							_tmp26_ = tokens;
							_tmp26__length1 = tokens_length1;
							_tmp27_ = _tmp26_[1];
							info.full = g_strcmp0 (_tmp27_, "full") == 0;
							_tmp28_ = info;
							_tmp29_ = _duplicity_job_date_info_dup0 (&_tmp28_);
							infos = g_list_append (infos, _tmp29_);
							_tmp31_ = self->priv->detected_encryption;
							if (!_tmp31_) {
								gchar** _tmp32_;
								gint _tmp32__length1;
								_tmp32_ = tokens;
								_tmp32__length1 = tokens_length1;
								_tmp30_ = _tmp32__length1 > 4;
							} else {
								_tmp30_ = FALSE;
							}
							if (_tmp30_) {
								gchar** _tmp33_;
								gint _tmp33__length1;
								const gchar* _tmp34_;
								self->priv->detected_encryption = TRUE;
								_tmp33_ = tokens;
								_tmp33__length1 = tokens_length1;
								_tmp34_ = _tmp33_[4];
								self->priv->existing_encrypted = g_strcmp0 (_tmp34_, "enc") == 0;
							}
						}
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
					} else {
						gboolean _tmp35_;
						_tmp35_ = in_chain;
						if (_tmp35_) {
							in_chain = FALSE;
						}
					}
				}
				_g_free0 (line);
			}
		}
	}
	self->priv->got_collection_info = TRUE;
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
	self->priv->collection_info = NULL;
	_tmp36_ = infos;
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp36_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			DuplicityJobDateInfo s = {0};
			s = *((DuplicityJobDateInfo*) s_it->data);
			{
				DuplicityJobDateInfo _tmp37_;
				DuplicityJobDateInfo* _tmp38_;
				_tmp37_ = s;
				_tmp38_ = _duplicity_job_date_info_dup0 (&_tmp37_);
				self->priv->collection_info = g_list_append (self->priv->collection_info, _tmp38_);
			}
		}
	}
	_tmp39_ = dates;
	g_signal_emit_by_name ((DejaDupToolJob*) self, "collection-dates", _tmp39_);
	(infos == NULL) ? NULL : (infos = (_g_list_free__duplicity_job_date_info_free0_ (infos), NULL));
	(dates == NULL) ? NULL : (dates = (_g_list_free__g_free0_ (dates), NULL));
}


static void
duplicity_job_real_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    int firstline_length1,
                                    GList* data,
                                    const gchar* text)
{
	g_return_if_fail (text != NULL);
	if (firstline_length1 > 1) {
		const gchar* _tmp0_;
		_tmp0_ = firstline[1];
		switch (atoi (_tmp0_)) {
			case DUPLICITY_JOB_WARNING_ORPHANED_SIG:
			case DUPLICITY_JOB_WARNING_UNNECESSARY_SIG:
			case DUPLICITY_JOB_WARNING_UNMATCHED_SIG:
			case DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP:
			case DUPLICITY_JOB_WARNING_ORPHANED_BACKUP:
			{
				gboolean _tmp1_ = FALSE;
				DejaDupToolJobMode _tmp2_;
				DejaDupToolJobMode _tmp3_;
				_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
				_tmp3_ = _tmp2_;
				if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
					gboolean _tmp4_;
					_tmp4_ = self->priv->cleaned_up_once;
					_tmp1_ = !_tmp4_;
				} else {
					_tmp1_ = FALSE;
				}
				if (_tmp1_) {
					duplicity_job_cleanup (self);
				}
				break;
			}
			case DUPLICITY_JOB_WARNING_CANNOT_READ:
			{
				if (firstline_length1 > 2) {
					GFile* error_file = NULL;
					const gchar* _tmp5_;
					GFile* _tmp6_;
					GList* _tmp7_;
					_tmp5_ = firstline[2];
					_tmp6_ = duplicity_job_make_file_obj (self, _tmp5_);
					error_file = _tmp6_;
					_tmp7_ = ((DejaDupToolJob*) self)->includes;
					{
						GList* f_collection = NULL;
						GList* f_it = NULL;
						f_collection = _tmp7_;
						for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
							GFile* _tmp8_;
							GFile* f = NULL;
							_tmp8_ = _g_object_ref0 ((GFile*) f_it->data);
							f = _tmp8_;
							{
								gboolean _tmp9_ = FALSE;
								GFile* _tmp10_;
								GFile* _tmp11_;
								_tmp10_ = error_file;
								_tmp11_ = f;
								if (g_file_equal (_tmp10_, _tmp11_)) {
									_tmp9_ = TRUE;
								} else {
									GFile* _tmp12_;
									GFile* _tmp13_;
									_tmp12_ = error_file;
									_tmp13_ = f;
									_tmp9_ = g_file_has_prefix (_tmp12_, _tmp13_);
								}
								if (_tmp9_) {
									GFile* _tmp14_;
									GFile* _tmp15_;
									_tmp14_ = error_file;
									_tmp15_ = _g_object_ref0 (_tmp14_);
									self->priv->local_error_files = g_list_append (self->priv->local_error_files, _tmp15_);
								}
								_g_object_unref0 (f);
							}
						}
					}
					_g_object_unref0 (error_file);
				}
				break;
			}
			case DUPLICITY_JOB_WARNING_CANNOT_PROCESS:
			{
				if (firstline_length1 > 2) {
					GFile* error_file = NULL;
					const gchar* _tmp16_;
					GFile* _tmp17_;
					gboolean _tmp18_ = FALSE;
					GFile* _tmp19_;
					GFile* _tmp20_;
					_tmp16_ = firstline[2];
					_tmp17_ = duplicity_job_make_file_obj (self, _tmp16_);
					error_file = _tmp17_;
					_tmp19_ = error_file;
					_tmp20_ = duplicity_job_slash;
					if (!g_file_equal (_tmp19_, _tmp20_)) {
						_tmp18_ = !string_contains (text, "[Errno 1]");
					} else {
						_tmp18_ = FALSE;
					}
					if (_tmp18_) {
						GFile* _tmp21_;
						GFile* _tmp22_;
						_tmp21_ = error_file;
						_tmp22_ = _g_object_ref0 (_tmp21_);
						self->priv->local_error_files = g_list_append (self->priv->local_error_files, _tmp22_);
					}
					_g_object_unref0 (error_file);
				}
				break;
			}
			default:
			break;
		}
	}
}


void
duplicity_job_process_warning (DuplicityJob* self,
                               gchar** firstline,
                               int firstline_length1,
                               GList* data,
                               const gchar* text)
{
	g_return_if_fail (self != NULL);
	DUPLICITY_JOB_GET_CLASS (self)->process_warning (self, firstline, firstline_length1, data, text);
}


static void
duplicity_job_show_error (DuplicityJob* self,
                          const gchar* errorstr,
                          const gchar* detail)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (errorstr != NULL);
	_tmp0_ = self->priv->_error_issued;
	if (_tmp0_ == FALSE) {
		duplicity_job_set_error_issued (self, TRUE);
		g_signal_emit_by_name ((DejaDupToolJob*) self, "raise-error", errorstr, detail);
	}
}


static gint
duplicity_job_get_volsize (DuplicityJob* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (deja_dup_in_testing_mode ()) {
		result = 1;
		return result;
	} else {
		DejaDupBackend* _tmp0_;
		DejaDupBackend* _tmp1_;
		_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
		_tmp1_ = _tmp0_;
		if (deja_dup_backend_is_native (_tmp1_)) {
			result = 50;
			return result;
		} else {
			result = 25;
			return result;
		}
	}
}


static void
_duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                    gboolean success,
                                                    gboolean cancelled,
                                                    gpointer self)
{
	duplicity_job_handle_done ((DuplicityJob*) self, _sender, success, cancelled);
}


static void
_duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                          gchar** control_line,
                                                          int control_line_length1,
                                                          GList* data_lines,
                                                          const gchar* user_text,
                                                          gpointer self)
{
	duplicity_job_handle_message ((DuplicityJob*) self, _sender, control_line, control_line_length1, data_lines, user_text);
}


static void
_duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                      gint code,
                                                      gpointer self)
{
	duplicity_job_handle_exit ((DuplicityJob*) self, code);
}


static void
duplicity_job_disconnect_inst (DuplicityJob* self)
{
	DuplicityInstance* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->inst;
	if (_tmp0_ != NULL) {
		DuplicityInstance* _tmp1_;
		guint _tmp2_;
		DuplicityInstance* _tmp3_;
		guint _tmp4_;
		DuplicityInstance* _tmp5_;
		guint _tmp6_;
		DuplicityInstance* _tmp7_;
		_tmp1_ = self->priv->inst;
		g_signal_parse_name ("done", TYPE_DUPLICITY_INSTANCE, &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self);
		_tmp3_ = self->priv->inst;
		g_signal_parse_name ("message", TYPE_DUPLICITY_INSTANCE, &_tmp4_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self);
		_tmp5_ = self->priv->inst;
		g_signal_parse_name ("exited", TYPE_DUPLICITY_INSTANCE, &_tmp6_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self);
		_tmp7_ = self->priv->inst;
		duplicity_instance_cancel (_tmp7_);
		_g_object_unref0 (self->priv->inst);
		self->priv->inst = NULL;
	}
}


static void
duplicity_job_connect_and_start (DuplicityJob* self,
                                 GList* argv_extra,
                                 GList* envp_extra,
                                 GList* argv_entire,
                                 GFile* custom_local)
{
	DuplicityInstance* _tmp0_;
	DuplicityInstance* _tmp1_;
	const gchar* _tmp2_;
	DuplicityInstance* _tmp5_;
	DuplicityInstance* _tmp6_;
	GList* _tmp7_ = NULL;
	GList* master_argv = NULL;
	GFile* _tmp9_ = NULL;
	GFile* local_arg = NULL;
	GList* argv = NULL;
	GList* _tmp12_;
	GList* _tmp16_;
	GList* envp = NULL;
	GList* _tmp50_;
	gboolean use_encryption = FALSE;
	gboolean _tmp57_;
	gboolean _tmp63_;
	DuplicityInstance* _tmp74_;
	GList* _tmp75_;
	GList* _tmp76_;
	gboolean _tmp77_;
	g_return_if_fail (self != NULL);
	duplicity_job_disconnect_inst (self);
	_tmp0_ = duplicity_instance_new ();
	_g_object_unref0 (self->priv->inst);
	self->priv->inst = _tmp0_;
	_tmp1_ = self->priv->inst;
	g_signal_connect_object (_tmp1_, "done", (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self, 0);
	_tmp2_ = self->priv->forced_cache_dir;
	if (_tmp2_ != NULL) {
		DuplicityInstance* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = self->priv->inst;
		_tmp4_ = self->priv->forced_cache_dir;
		duplicity_instance_set_forced_cache_dir (_tmp3_, _tmp4_);
	}
	_tmp5_ = self->priv->inst;
	g_signal_connect_object (_tmp5_, "message", (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self, 0);
	_tmp6_ = self->priv->inst;
	g_signal_connect_object (_tmp6_, "exited", (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self, 0);
	if (argv_entire == NULL) {
		GList* _tmp8_;
		_tmp8_ = self->priv->saved_argv;
		_tmp7_ = _tmp8_;
	} else {
		_tmp7_ = argv_entire;
	}
	master_argv = _tmp7_;
	if (custom_local == NULL) {
		GFile* _tmp10_;
		GFile* _tmp11_;
		_tmp10_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
		_tmp11_ = _tmp10_;
		_tmp9_ = _tmp11_;
	} else {
		_tmp9_ = custom_local;
	}
	local_arg = _tmp9_;
	argv = NULL;
	_tmp12_ = master_argv;
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp12_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp13_;
			gchar* s = NULL;
			_tmp13_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp13_;
			{
				const gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp14_ = s;
				_tmp15_ = g_strdup (_tmp14_);
				argv = g_list_append (argv, _tmp15_);
				_g_free0 (s);
			}
		}
	}
	_tmp16_ = self->priv->backend_argv;
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp16_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp17_;
			gchar* s = NULL;
			_tmp17_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp17_;
			{
				const gchar* _tmp18_;
				gchar* _tmp19_;
				_tmp18_ = s;
				_tmp19_ = g_strdup (_tmp18_);
				argv = g_list_append (argv, _tmp19_);
				_g_free0 (s);
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = argv_extra;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp20_;
			gchar* s = NULL;
			_tmp20_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp20_;
			{
				const gchar* _tmp21_;
				gchar* _tmp22_;
				_tmp21_ = s;
				_tmp22_ = g_strdup (_tmp21_);
				argv = g_list_append (argv, _tmp22_);
				_g_free0 (s);
			}
		}
	}
	if (argv_entire == NULL) {
		DejaDupToolJobMode _tmp23_;
		DejaDupToolJobMode _tmp24_;
		_tmp23_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
		_tmp24_ = _tmp23_;
		switch (_tmp24_) {
			case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
			{
				gboolean _tmp25_;
				gchar* _tmp27_;
				GFile* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				_tmp25_ = self->priv->is_full_backup;
				if (_tmp25_) {
					gchar* _tmp26_;
					_tmp26_ = g_strdup ("full");
					argv = g_list_prepend (argv, _tmp26_);
				}
				_tmp27_ = g_strdup_printf ("--volsize=%d", duplicity_job_get_volsize (self));
				argv = g_list_append (argv, _tmp27_);
				_tmp28_ = local_arg;
				_tmp29_ = g_file_get_path (_tmp28_);
				argv = g_list_append (argv, _tmp29_);
				_tmp30_ = duplicity_job_get_remote (self);
				argv = g_list_append (argv, _tmp30_);
				break;
			}
			case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
			{
				gchar* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GFile* _tmp39_;
				gchar* _tmp40_;
				_tmp31_ = g_strdup ("restore");
				argv = g_list_prepend (argv, _tmp31_);
				_tmp32_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
				_tmp33_ = _tmp32_;
				if (_tmp33_ != NULL) {
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					gchar* _tmp36_;
					_tmp34_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
					_tmp35_ = _tmp34_;
					_tmp36_ = g_strdup_printf ("--time=%s", _tmp35_);
					argv = g_list_append (argv, _tmp36_);
				}
				_tmp37_ = g_strdup ("--force");
				argv = g_list_append (argv, _tmp37_);
				_tmp38_ = duplicity_job_get_remote (self);
				argv = g_list_append (argv, _tmp38_);
				_tmp39_ = local_arg;
				_tmp40_ = g_file_get_path (_tmp39_);
				argv = g_list_append (argv, _tmp40_);
				break;
			}
			case DEJA_DUP_TOOL_JOB_MODE_STATUS:
			{
				gchar* _tmp41_;
				gchar* _tmp42_;
				_tmp41_ = g_strdup ("collection-status");
				argv = g_list_prepend (argv, _tmp41_);
				_tmp42_ = duplicity_job_get_remote (self);
				argv = g_list_append (argv, _tmp42_);
				break;
			}
			case DEJA_DUP_TOOL_JOB_MODE_LIST:
			{
				gchar* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				gchar* _tmp49_;
				_tmp43_ = g_strdup ("list-current-files");
				argv = g_list_prepend (argv, _tmp43_);
				_tmp44_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
				_tmp45_ = _tmp44_;
				if (_tmp45_ != NULL) {
					const gchar* _tmp46_;
					const gchar* _tmp47_;
					gchar* _tmp48_;
					_tmp46_ = deja_dup_tool_job_get_time ((DejaDupToolJob*) self);
					_tmp47_ = _tmp46_;
					_tmp48_ = g_strdup_printf ("--time=%s", _tmp47_);
					argv = g_list_append (argv, _tmp48_);
				}
				_tmp49_ = duplicity_job_get_remote (self);
				argv = g_list_append (argv, _tmp49_);
				break;
			}
			default:
			break;
		}
	}
	envp = NULL;
	_tmp50_ = self->priv->saved_envp;
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp50_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp51_;
			gchar* s = NULL;
			_tmp51_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp51_;
			{
				const gchar* _tmp52_;
				gchar* _tmp53_;
				_tmp52_ = s;
				_tmp53_ = g_strdup (_tmp52_);
				envp = g_list_append (envp, _tmp53_);
				_g_free0 (s);
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = envp_extra;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			gchar* _tmp54_;
			gchar* s = NULL;
			_tmp54_ = g_strdup ((const gchar*) s_it->data);
			s = _tmp54_;
			{
				const gchar* _tmp55_;
				gchar* _tmp56_;
				_tmp55_ = s;
				_tmp56_ = g_strdup (_tmp55_);
				envp = g_list_append (envp, _tmp56_);
				_g_free0 (s);
			}
		}
	}
	use_encryption = FALSE;
	_tmp57_ = self->priv->detected_encryption;
	if (_tmp57_) {
		gboolean _tmp58_;
		_tmp58_ = self->priv->existing_encrypted;
		use_encryption = _tmp58_;
	} else {
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		_tmp59_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
		_tmp60_ = _tmp59_;
		if (_tmp60_ != NULL) {
			const gchar* _tmp61_;
			const gchar* _tmp62_;
			_tmp61_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
			_tmp62_ = _tmp61_;
			use_encryption = g_strcmp0 (_tmp62_, "") != 0;
		}
	}
	_tmp63_ = use_encryption;
	if (_tmp63_) {
		gboolean _tmp64_ = FALSE;
		const gchar* _tmp65_;
		const gchar* _tmp66_;
		_tmp65_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
		_tmp66_ = _tmp65_;
		if (_tmp66_ != NULL) {
			const gchar* _tmp67_;
			const gchar* _tmp68_;
			_tmp67_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
			_tmp68_ = _tmp67_;
			_tmp64_ = g_strcmp0 (_tmp68_, "") != 0;
		} else {
			_tmp64_ = FALSE;
		}
		if (_tmp64_) {
			const gchar* _tmp69_;
			const gchar* _tmp70_;
			gchar* _tmp71_;
			_tmp69_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
			_tmp70_ = _tmp69_;
			_tmp71_ = g_strdup_printf ("PASSPHRASE=%s", _tmp70_);
			envp = g_list_append (envp, _tmp71_);
		}
	} else {
		gchar* _tmp72_;
		gchar* _tmp73_;
		_tmp72_ = g_strdup ("--no-encryption");
		argv = g_list_append (argv, _tmp72_);
		_tmp73_ = g_strdup ("PASSPHRASE=");
		envp = g_list_append (envp, _tmp73_);
	}
	_tmp74_ = self->priv->inst;
	_tmp75_ = argv;
	_tmp76_ = envp;
	_tmp77_ = self->priv->needs_root;
	duplicity_instance_start (_tmp74_, _tmp75_, _tmp76_, _tmp77_, NULL, NULL);
	(envp == NULL) ? NULL : (envp = (_g_list_free__g_free0_ (envp), NULL));
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
}


DuplicityJob*
duplicity_job_construct (GType object_type)
{
	DuplicityJob * self = NULL;
	self = (DuplicityJob*) deja_dup_tool_job_construct (object_type);
	return self;
}


DuplicityJob*
duplicity_job_new (void)
{
	return duplicity_job_construct (TYPE_DUPLICITY_JOB);
}


static DejaDupToolJobMode
duplicity_job_get_original_mode (DuplicityJob* self)
{
	DejaDupToolJobMode result;
	DejaDupToolJobMode _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_original_mode;
	result = _tmp0_;
	return result;
}


static void
duplicity_job_set_original_mode (DuplicityJob* self,
                                 DejaDupToolJobMode value)
{
	g_return_if_fail (self != NULL);
	self->priv->_original_mode = value;
}


static gboolean
duplicity_job_get_error_issued (DuplicityJob* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_error_issued;
	result = _tmp0_;
	return result;
}


static void
duplicity_job_set_error_issued (DuplicityJob* self,
                                gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_error_issued = value;
}


static gboolean
duplicity_job_get_was_stopped (DuplicityJob* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_was_stopped;
	result = _tmp0_;
	return result;
}


static void
duplicity_job_set_was_stopped (DuplicityJob* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_was_stopped = value;
}


DuplicityJobState
duplicity_job_get_state (DuplicityJob* self)
{
	DuplicityJobState result;
	DuplicityJobState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


void
duplicity_job_set_state (DuplicityJob* self,
                         DuplicityJobState value)
{
	g_return_if_fail (self != NULL);
	if (duplicity_job_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY]);
	}
}


static GObject *
duplicity_job_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DuplicityJob * self;
	GFile* _tmp0_;
	parent_class = G_OBJECT_CLASS (duplicity_job_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
	_tmp0_ = duplicity_job_slash;
	if (_tmp0_ == NULL) {
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		_tmp1_ = g_file_new_for_path ("/");
		_g_object_unref0 (duplicity_job_slash);
		duplicity_job_slash = _tmp1_;
		_tmp2_ = g_file_new_for_path ("/root");
		_g_object_unref0 (duplicity_job_slash_root);
		duplicity_job_slash_root = _tmp2_;
		_tmp3_ = g_file_new_for_path ("/home");
		_g_object_unref0 (duplicity_job_slash_home);
		duplicity_job_slash_home = _tmp3_;
		_tmp4_ = g_get_home_dir ();
		_tmp5_ = g_file_new_for_path (_tmp4_);
		_g_object_unref0 (duplicity_job_slash_home_me);
		duplicity_job_slash_home_me = _tmp5_;
	}
	return obj;
}


static DuplicityJobDateInfo*
duplicity_job_date_info_dup (const DuplicityJobDateInfo* self)
{
	DuplicityJobDateInfo* dup;
	dup = g_new0 (DuplicityJobDateInfo, 1);
	memcpy (dup, self, sizeof (DuplicityJobDateInfo));
	return dup;
}


static void
duplicity_job_date_info_free (DuplicityJobDateInfo* self)
{
	g_free (self);
}


static GType
duplicity_job_date_info_get_type (void)
{
	static volatile gsize duplicity_job_date_info_type_id__volatile = 0;
	if (g_once_init_enter (&duplicity_job_date_info_type_id__volatile)) {
		GType duplicity_job_date_info_type_id;
		duplicity_job_date_info_type_id = g_boxed_type_register_static ("DuplicityJobDateInfo", (GBoxedCopyFunc) duplicity_job_date_info_dup, (GBoxedFreeFunc) duplicity_job_date_info_free);
		g_once_init_leave (&duplicity_job_date_info_type_id__volatile, duplicity_job_date_info_type_id);
	}
	return duplicity_job_date_info_type_id__volatile;
}


static void
duplicity_job_class_init (DuplicityJobClass * klass)
{
	duplicity_job_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DuplicityJobPrivate));
	((DejaDupToolJobClass *) klass)->start = (void (*) (DejaDupToolJob *)) duplicity_job_real_start;
	((DejaDupToolJobClass *) klass)->cancel = (void (*) (DejaDupToolJob *)) duplicity_job_real_cancel;
	((DejaDupToolJobClass *) klass)->stop = (void (*) (DejaDupToolJob *)) duplicity_job_real_stop;
	((DejaDupToolJobClass *) klass)->pause = (void (*) (DejaDupToolJob *, const gchar*)) duplicity_job_real_pause;
	((DejaDupToolJobClass *) klass)->resume = (void (*) (DejaDupToolJob *)) duplicity_job_real_resume;
	((DuplicityJobClass *) klass)->process_error = (void (*) (DuplicityJob *, gchar**, int, GList*, const gchar*)) duplicity_job_real_process_error;
	((DuplicityJobClass *) klass)->process_info = (void (*) (DuplicityJob *, gchar**, int, GList*, const gchar*)) duplicity_job_real_process_info;
	((DuplicityJobClass *) klass)->process_warning = (void (*) (DuplicityJob *, gchar**, int, GList*, const gchar*)) duplicity_job_real_process_warning;
	G_OBJECT_CLASS (klass)->get_property = _vala_duplicity_job_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_duplicity_job_set_property;
	G_OBJECT_CLASS (klass)->constructor = duplicity_job_constructor;
	G_OBJECT_CLASS (klass)->finalize = duplicity_job_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUPLICITY_JOB_STATE_PROPERTY, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", DUPLICITY_JOB_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
duplicity_job_instance_init (DuplicityJob * self)
{
	self->priv = DUPLICITY_JOB_GET_PRIVATE (self);
	self->priv->_error_issued = FALSE;
	self->priv->_was_stopped = FALSE;
	self->priv->is_full_backup = FALSE;
	self->priv->cleaned_up_once = FALSE;
	self->priv->needs_root = FALSE;
	self->priv->detected_encryption = FALSE;
	self->priv->existing_encrypted = FALSE;
	self->priv->has_progress_total = FALSE;
	self->priv->has_checked_contents = FALSE;
	self->priv->has_non_home_contents = FALSE;
	self->priv->homes = NULL;
	self->priv->local_error_files = NULL;
	self->priv->checked_collection_info = FALSE;
	self->priv->got_collection_info = FALSE;
	self->priv->collection_info = NULL;
	self->priv->checked_backup_space = FALSE;
	self->priv->deleted_files = FALSE;
	self->priv->delete_age = 0;
	self->priv->last_touched_file = NULL;
	self->priv->forced_cache_dir = NULL;
	self->priv->restarted_without_cache = FALSE;
}


static void
duplicity_job_finalize (GObject * obj)
{
	DuplicityJob * self;
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
	_tmp0_ = deja_dup_network_get ();
	_tmp1_ = _tmp0_;
	g_signal_parse_name ("notify::connected", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _duplicity_job_network_changed_g_object_notify, self);
	_g_object_unref0 (_tmp1_);
	_g_object_unref0 (self->priv->inst);
	(self->priv->backend_argv == NULL) ? NULL : (self->priv->backend_argv = (_g_list_free__g_free0_ (self->priv->backend_argv), NULL));
	(self->priv->saved_argv == NULL) ? NULL : (self->priv->saved_argv = (_g_list_free__g_free0_ (self->priv->saved_argv), NULL));
	(self->priv->saved_envp == NULL) ? NULL : (self->priv->saved_envp = (_g_list_free__g_free0_ (self->priv->saved_envp), NULL));
	_g_free0 (self->priv->last_bad_volume);
	(self->priv->homes == NULL) ? NULL : (self->priv->homes = (_g_list_free__g_object_unref0_ (self->priv->homes), NULL));
	(self->priv->local_error_files == NULL) ? NULL : (self->priv->local_error_files = (_g_list_free__g_object_unref0_ (self->priv->local_error_files), NULL));
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
	_g_object_unref0 (self->priv->last_touched_file);
	_g_free0 (self->priv->forced_cache_dir);
	_g_free0 (self->priv->saved_status);
	_g_object_unref0 (self->priv->saved_status_file);
	G_OBJECT_CLASS (duplicity_job_parent_class)->finalize (obj);
}


GType
duplicity_job_get_type (void)
{
	return duplicity_job_type_id;
}


GType
duplicity_job_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (DuplicityJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) duplicity_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DuplicityJob), 0, (GInstanceInitFunc) duplicity_job_instance_init, NULL };
	duplicity_job_type_id = g_type_module_register_type (module, DEJA_DUP_TYPE_TOOL_JOB, "DuplicityJob", &g_define_type_info, 0);
	return duplicity_job_type_id;
}


static void
_vala_duplicity_job_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
	switch (property_id) {
		case DUPLICITY_JOB_STATE_PROPERTY:
		g_value_set_enum (value, duplicity_job_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_duplicity_job_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
	switch (property_id) {
		case DUPLICITY_JOB_STATE_PROPERTY:
		duplicity_job_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



